#****************************************************************************
#**
#**  File     :  /cdimage/lua/modules/armordefinition.lua
#**  Author(s):
#**
#**  Summary  :
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************
#
# Armor Type Definitions
#

armordefinition = {

    {   # Armor Type Name
        'Default',

        # Armor Definition
        'Normal 1.0',
    },

--============================================================

    {   # Armor Type Name
        'Normal',

        # Armor Definition
        'Normal 1.0',
        'T1AA 1.0',
        'Flak 0',
    },

--==============================

    {   # Armor Type Name
        'Light',

        # Armor Definition
        'Normal 1.0',
    },

--============================================================

    {   # Armor Type Name
        'NormalAircraft',

        # Armor Definition
        'Normal 1.0',
        'T1AA 1.0',
        'Flak 0.5',
    },

--============================================================

    {
        'Gunship',
-------------------------
        'Normal 1.0',
        'Flak 1.5',
        'T1AA 0.5',
    },

--============================================================

    {
        'Bomber',
-------------------------
        'Normal 1.0',
        'T1AA 1.0',
        'Flak 0.7',
    },

--============================================================

    {
        'Scout',
-------------------------
        'Normal 1.0',
        'T1AA 1.0',
        'Flak 0.05',
    },

--============================================================

    {
        'ASF',
-------------------------
        'AAM 0.2',
        'SAM 0.5',
    },

--============================================================

    {
        'Transport',
-------------------------
        'AAM 0.1',
        'SAM 0.1',
    },

--============================================================

    {
        'ShipHull',
------------------------------
        'Normal 1.0',
        'PointDefense 1.0',
        'NavalCannon 1.0',
        'Torpedo 1.0',
        'Artillery 1.0',
        'Missile 1.0',
        'Nuke 1.0',
        'AntiSub 1.0',
    },

--============================================================

    {
        'Structure',
------------------------------
        'Normal 1.0',
        'Torpedo 0.4',
        'AntiSub 0.4',
        'Flak 0',
    },

--============================================================

    {
        'CrawlingBomb',
------------------------------
        'Normal 1.0',
        'CrawlingBomb 0.02',
    },

--============================================================

    {
        'Submarine',
------------------------------
        'Normal 1.0',
        'Torpedo 1.0',
        'AntiSub 1.0',
    },

--============================================================

    {
        'Commander',
------------------------------
        'Normal 1.0',
        'Torpedo 0.5',
        'AntiSub 0.5',
    },
}
