do

local oldModBlueprints = ModBlueprints

function ModBlueprints(all_bps)
    oldModBlueprints(all_bps)


--                                                                                         
--                                     TAG REMOVAL                                         
--                                                                                         


    all_bps.Unit["ual0001"].Enhancements.CrysalisBeam = {}
    all_bps.Unit["ual0001"].Enhancements.CrysalisBeamRemove = {}
    all_bps.Unit["ual0001"].Enhancements.EnhancedSensors = {}           -- Can't get this working yet
    all_bps.Unit["ual0001"].Enhancements.EnhancedSensorsRemove = {}
    all_bps.Unit["ual0001"].Enhancements.HeatSink = {}
    all_bps.Unit["ual0001"].Enhancements.HeatSinkRemove = {}
    all_bps.Unit["ual0001"].Enhancements.ResourceAllocation = {}
    all_bps.Unit["ual0001"].Enhancements.ResourceAllocationRemove = {}
    all_bps.Unit["ual0001"].Enhancements.Shield = {}
    all_bps.Unit["ual0001"].Enhancements.ShieldRemove = {}
    all_bps.Unit["ual0001"].Enhancements.ShieldHeavy = {}
    all_bps.Unit["ual0001"].Enhancements.ShieldHeavyRemove = {}

    all_bps.Unit["uel0001"].Enhancements.ResourceAllocation = {}
    all_bps.Unit["uel0001"].Enhancements.ResourceAllocationRemove = {}
    all_bps.Unit["uel0001"].Enhancements.HeavyAntiMatterCannon = {}
    all_bps.Unit["uel0001"].Enhancements.HeavyAntiMatterCannonRemove = {}
    all_bps.Unit["uel0001"].Enhancements.Shield = {}
    all_bps.Unit["uel0001"].Enhancements.ShieldRemove = {}
    all_bps.Unit["uel0001"].Enhancements.ShieldGeneratorField = {}
    all_bps.Unit["uel0001"].Enhancements.ShieldGeneratorFieldRemove = {}

    all_bps.Unit["url0001"].Enhancements.ResourceAllocation = {}
    all_bps.Unit["url0001"].Enhancements.ResourceAllocationRemove = {}
    all_bps.Unit["url0001"].Enhancements.CoolingUpgrade = {}
    all_bps.Unit["url0001"].Enhancements.CoolingUpgradeRemove = {}
    all_bps.Unit["url0001"].Enhancements.MicrowaveLaserGenerator = {}
    all_bps.Unit["url0001"].Enhancements.MicrowaveLaserGeneratorRemove = {}

    all_bps.Unit["xsl0001"].Enhancements.ResourceAllocation = {}
    all_bps.Unit["xsl0001"].Enhancements.ResourceAllocationRemove = {}
    all_bps.Unit["xsl0001"].Enhancements.RateOfFire = {}
    all_bps.Unit["xsl0001"].Enhancements.RateOfFireRemove = {}

    all_bps.Unit["ual0301"].Enhancements.ResourceAllocation = {}
    all_bps.Unit["ual0301"].Enhancements.ResourceAllocationRemove = {}
    all_bps.Unit["ual0301"].Enhancements.Teleporter = {}
    all_bps.Unit["ual0301"].Enhancements.TeleporterRemove = {}
    all_bps.Unit["ual0301"].Enhancements.Sacrifice = {}

    all_bps.Unit["ual0301"].Enhancements.SacrificeRemove = {}
    all_bps.Unit["uel0301"].Enhancements.ResourceAllocation = {}
    all_bps.Unit["uel0301"].Enhancements.ResourceAllocationRemove = {}
    all_bps.Unit["uel0301"].Enhancements.SensorRangeEnhancer = {}
    all_bps.Unit["uel0301"].Enhancements.SensorRangeEnhancerRemove = {}

    all_bps.Unit["url0301"].Enhancements.ResourceAllocation = {}
    all_bps.Unit["url0301"].Enhancements.ResourceAllocationRemove = {}

    all_bps.Unit["xsl0301"].Enhancements.ResourceAllocation = {}
    all_bps.Unit["xsl0301"].Enhancements.ResourceAllocationRemove = {}
    all_bps.Unit["xsl0301"].Enhancements.Teleporter = {}
    all_bps.Unit["xsl0301"].Enhancements.TeleporterRemove = {}
    all_bps.Unit["xsl0301"].Enhancements.EnhancedSensors = {}
    all_bps.Unit["xsl0301"].Enhancements.EnhancedSensorsRemove = {}

    all_bps.Unit["url0001"].Weapon[4].EnabledByEnhancement = nil
    all_bps.Unit["ual0303"].Defense.Shield = {}                                         -- Aeon Harbinger
    all_bps.Unit["uel0303"].Defense.Shield = {}                                         -- UEF Titan
    --all_bps.Unit["uel0401"].Defense.Shield = {}                                         -- UEF Ogre
                                                                                        -- UEF Pillar
    all_bps.Unit["uel0202"].Weapon[1].RackBones = {
        {
            MuzzleBones = {
                'Turret_Muzzle_01',
            },
            RackBone = 'Turret_Barrel_01',
        },
        {
            MuzzleBones = {
                'Turret_Muzzle_02',
                },
            RackBone = 'Turret_Barrel_02',
        },
    }
                                                                                        -- UEF Triad
    all_bps.Unit["ueb2301"].Weapon[1].RackBones = {
        {
            MuzzleBones = {
                'Turret_Muzzle01',
            },
            RackBone = 'Turret_Recoil03',
        },
        {
            MuzzleBones = {
                'Turret_Muzzle02',
            },
            RackBone = 'Turret_Recoil02',
        },
        {
            MuzzleBones = {
                'Turret_Muzzle03',
            },
            RackBone = 'Turret_Recoil01',
        },
    }
    all_bps.Unit["xrs0204"].Weapon[1].RackBones = {
        {
            MuzzleBones = {
                'Torpedo_Muzzle02',
                'Torpedo_Muzzle03',
            },
            RackBone = 'Torpedo_Muzzle02',
        },
    }
    all_bps.Unit["xrs0204"].Weapon[2].RackBones = {
        {
            MuzzleBones = {
                'Torpedo_Muzzle01',
            },
            RackBone = 'Torpedo_Muzzle01',
        },
    }

    all_bps.Unit["uas0201"].Weapon[4] = nil
    all_bps.Unit["ues0201"].Weapon[5] = nil
    all_bps.Unit["urs0201"].Weapon[4] = nil
    all_bps.Unit["xss0201"].Weapon[4] = nil



--                                                                                         
--                                     WEAPONS                                             
--                                                                                         

    all_bps.Unit["ual0001"].Weapon[1].TargetPriorities = ACU_Cannon                     -- Aeon ACU
    all_bps.Unit["uel0001"].Weapon[1].TargetPriorities = ACU_Cannon                     -- UEF ACU
    all_bps.Unit["url0001"].Weapon[1].TargetPriorities = ACU_Cannon                     -- Cybran ACU
    all_bps.Unit["xsl0001"].Weapon[1].TargetPriorities = ACU_Cannon                     -- Seraphim ACU
    all_bps.Unit["ual0303"].Weapon[1].TargetPriorities = Extreme_Assault_FastReload     -- Aeon Harbinger
    all_bps.Unit["xal0305"].Weapon[1].TargetPriorities = Extreme_Assault_SlowReload     -- Aeon Sprite
    all_bps.Unit["uel0303"].Weapon[1].TargetPriorities = Extreme_Assault_FastReload     -- UEF Titan
    all_bps.Unit["xel0305"].Weapon[1].TargetPriorities = Extreme_Assault_SlowReload     -- UEF Percival
    all_bps.Unit["url0303"].Weapon[1].TargetPriorities = Extreme_Assault_SlowReload     -- Cybran Loyalist
    all_bps.Unit["url0303"].Weapon[2].TargetPriorities = Extreme_Assault_FastReload     -- Cybran Loyalist
    all_bps.Unit["xrl0305"].Weapon[1].TargetPriorities = Extreme_Assault_FastReload     -- Cybran Brick
    all_bps.Unit["xrl0305"].Weapon[2].TargetPriorities = T1_Torpedo                     -- Cybran Brick
    all_bps.Unit["xsl0303"].Weapon[1].TargetPriorities = Extreme_Assault_SlowReload     -- Seraphim Extreme Assault Tank
    all_bps.Unit["xsl0303"].Weapon[2].TargetPriorities = T1_Torpedo                     -- Seraphim Extreme Assault Tank
    all_bps.Unit["xsl0303"].Weapon[3].TargetPriorities = Extreme_Assault_FastReload     -- Seraphim Extreme Assault Tank
    all_bps.Unit["xsl0303"].Weapon[4].TargetPriorities = Extreme_Assault_FastReload     -- Seraphim Extreme Assault Tank
    all_bps.Unit["xsl0305"].Weapon[1].TargetPriorities = Extreme_Assault_SlowReload     -- Seraphim Sniper Bot
    all_bps.Unit["xsl0305"].Weapon[2].TargetPriorities = Extreme_Assault_SlowReload     -- Seraphim Sniper Bot
    all_bps.Unit["dal0310"].Weapon[1].TargetPriorities = AntiShield                     -- Aeon Absolver
    all_bps.Unit["uas0302"].Weapon[1].TargetPriorities = Heavy_Naval_Artillery          -- Aeon Battleship
    all_bps.Unit["uas0302"].Weapon[2].TargetPriorities = Heavy_Naval_Artillery          -- Aeon Battleship
    all_bps.Unit["uas0302"].Weapon[3].TargetPriorities = Heavy_Naval_Artillery          -- Aeon Battleship
    all_bps.Unit["uas0302"].Weapon[4].TargetPriorities = Cruiser_AA                     -- Aeon Battleship
    all_bps.Unit["ues0302"].Weapon[1].TargetPriorities = Heavy_Naval_Artillery          -- UEF Battleship
    all_bps.Unit["ues0302"].Weapon[2].TargetPriorities = Heavy_Naval_Artillery          -- UEF Battleship
    all_bps.Unit["ues0302"].Weapon[3].TargetPriorities = Heavy_Naval_Artillery          -- UEF Battleship
    all_bps.Unit["ues0302"].Weapon[4].TargetPriorities = Cruiser_AA                     -- UEF Battleship
    all_bps.Unit["ues0302"].Weapon[5].TargetPriorities = Cruiser_AA                     -- UEF Battleship
    all_bps.Unit["ues0302"].Weapon[6].TargetPriorities = Cruiser_AA                     -- UEF Battleship
    all_bps.Unit["ues0302"].Weapon[7].TargetPriorities = Cruiser_AA                     -- UEF Battleship
    all_bps.Unit["urs0302"].Weapon[1].TargetPriorities = Heavy_Naval_Artillery          -- Cybran Battleship
    all_bps.Unit["urs0302"].Weapon[2].TargetPriorities = Heavy_Naval_Artillery          -- Cybran Battleship
    all_bps.Unit["urs0302"].Weapon[3].TargetPriorities = Cruiser_AA                     -- Cybran Battleship
    all_bps.Unit["urs0302"].Weapon[4].TargetPriorities = Cruiser_AA                     -- Cybran Battleship
    all_bps.Unit["urs0302"].Weapon[5].TargetPriorities = AntiSub                        -- Cybran Battleship
    all_bps.Unit["xss0302"].Weapon[1].TargetPriorities = Heavy_Naval_Artillery          -- Seraphim Battleship
    all_bps.Unit["xss0302"].Weapon[2].TargetPriorities = Heavy_Naval_Artillery          -- Seraphim Battleship
    all_bps.Unit["xss0302"].Weapon[3].TargetPriorities = Heavy_Naval_Artillery          -- Seraphim Battleship
    all_bps.Unit["xss0302"].Weapon[6].TargetPriorities = Cruiser_AA                     -- Seraphim Battleship
    all_bps.Unit["xss0302"].Weapon[7].TargetPriorities = Cruiser_AA                     -- Seraphim Battleship
    all_bps.Unit["xes0307"].Weapon[1].TargetPriorities = Heavy_Naval_Cannon             -- UEF Battlecruiser
    all_bps.Unit["xes0307"].Weapon[2].TargetPriorities = Heavy_Naval_Cannon             -- UEF Battlecruiser
    all_bps.Unit["xes0307"].Weapon[3].TargetPriorities = AntiSub                        -- UEF Battlecruiser
    all_bps.Unit["ueb2401"].Weapon[1].TargetPriorities = Long_Range_Artillery           -- UEF Mavor
    all_bps.Unit["xea0002"].Weapon[1].TargetPriorities = Long_Range_Artillery           -- UEF Novax Satellite
    all_bps.Unit["uel0401"].Weapon[1].TargetPriorities = Heavy_Naval_Artillery          -- UEF Ogre
    all_bps.Unit["uel0401"].Weapon[2].TargetPriorities = Heavy_Naval_Artillery          -- UEF Ogre
    all_bps.Unit["uel0401"].Weapon[3].TargetPriorities = Heavy_Naval_Artillery          -- UEF Ogre
    all_bps.Unit["uel0401"].Weapon[4].TargetPriorities = Heavy_Naval_Artillery          -- UEF Ogre
    all_bps.Unit["uel0401"].Weapon[5].TargetPriorities = T1_Point_Defense               -- UEF Ogre
    all_bps.Unit["uel0401"].Weapon[6].TargetPriorities = T1_Point_Defense               -- UEF Ogre
    all_bps.Unit["uel0401"].Weapon[7].TargetPriorities = Medium_AA_Gun                  -- UEF Ogre
    all_bps.Unit["uel0401"].Weapon[8].TargetPriorities = Medium_AA_Gun                  -- UEF Ogre
    all_bps.Unit["uel0401"].Weapon[9].TargetPriorities = AntiSub                        -- UEF Ogre
    all_bps.Unit["ual0401"].Weapon[1].TargetPriorities = Beam_Of_Death                  -- Aeon Colossus
    all_bps.Unit["ual0401"].Weapon[2].TargetPriorities = Tractor_Claw                   -- Aeon Colossus
    all_bps.Unit["ual0401"].Weapon[3].TargetPriorities = Tractor_Claw                   -- Aeon Colossus
    all_bps.Unit["url0402"].Weapon[1].TargetPriorities = Beam_Of_Death                  -- Cybran Nemesis
    all_bps.Unit["url0402"].Weapon[2].TargetPriorities = Extreme_Assault_FastReload     -- Cybran Nemesis
    all_bps.Unit["url0402"].Weapon[3].TargetPriorities = Extreme_Assault_FastReload     -- Cybran Nemesis
    all_bps.Unit["url0402"].Weapon[4].TargetPriorities = Medium_AA_Gun                  -- Cybran Nemesis
    all_bps.Unit["url0402"].Weapon[5].TargetPriorities = Medium_AA_Gun                  -- Cybran Nemesis
    all_bps.Unit["url0402"].Weapon[6].TargetPriorities = AntiSub                        -- Cybran Nemesis
    all_bps.Unit["url0401"].Weapon[1].TargetPriorities = Long_Range_Artillery           -- Cybran Scathis
    all_bps.Unit["xrl0403"].Weapon[1].TargetPriorities = Extreme_Assault_SlowReload     -- Cybran Megalith
    all_bps.Unit["xrl0403"].Weapon[2].TargetPriorities = Extreme_Assault_SlowReload     -- Cybran Megalith
    all_bps.Unit["xrl0403"].Weapon[3].TargetPriorities = AntiSub                        -- Cybran Megalith
    all_bps.Unit["xrl0403"].Weapon[5].TargetPriorities = Flak                           -- Cybran Megalith
    all_bps.Unit["xsl0401"].Weapon[1].TargetPriorities = Extreme_Assault_SlowReload     -- Seraphim ChickenBot
    all_bps.Unit["xsl0401"].Weapon[2].TargetPriorities = Beam_Of_Death                  -- Seraphim ChickenBot
    all_bps.Unit["xsl0401"].Weapon[3].TargetPriorities = Extreme_Assault_SlowReload     -- Seraphim ChickenBot
    all_bps.Unit["xsl0401"].Weapon[4].TargetPriorities = Flak                           -- Seraphim ChickenBot
    all_bps.Unit["xsl0401"].Weapon[5].TargetPriorities = Flak                           -- Seraphim ChickenBot
    all_bps.Unit["uaa0310"].Weapon[1].TargetPriorities = Beam_Of_Death                  -- Aeon Czar
    all_bps.Unit["uaa0310"].Weapon[2].TargetPriorities = Medium_AA_Gun                  -- Aeon Czar
    all_bps.Unit["uaa0310"].Weapon[3].TargetPriorities = Medium_AA_Gun                  -- Aeon Czar
    all_bps.Unit["uaa0310"].Weapon[4].TargetPriorities = Medium_AA_Gun                  -- Aeon Czar
    all_bps.Unit["uaa0310"].Weapon[5].TargetPriorities = Medium_AA_Gun                  -- Aeon Czar
    all_bps.Unit["uaa0310"].Weapon[6].TargetPriorities = T1_Torpedo                     -- Aeon Czar
    all_bps.Unit["uaa0310"].Weapon[7].TargetPriorities = T1_Torpedo                     -- Aeon Czar
    all_bps.Unit["uaa0310"].Weapon[8].TargetPriorities = Flak                           -- Aeon Czar
    all_bps.Unit["uaa0310"].Weapon[9].TargetPriorities = Flak                           -- Aeon Czar
    all_bps.Unit["ura0401"].Weapon[1].TargetPriorities = Extreme_Assault_FastReload     -- Cybran Reaver
    all_bps.Unit["ura0401"].Weapon[2].TargetPriorities = Extreme_Assault_FastReload     -- Cybran Reaver
    all_bps.Unit["ura0401"].Weapon[3].TargetPriorities = Medium_AA_Gun                  -- Cybran Reaver
    all_bps.Unit["ura0401"].Weapon[4].TargetPriorities = Medium_AA_Gun                  -- Cybran Reaver
    all_bps.Unit["ura0401"].Weapon[5].TargetPriorities = Extreme_Assault_FastReload     -- Cybran Reaver
    all_bps.Unit["ura0401"].Weapon[6].TargetPriorities = Extreme_Assault_FastReload     -- Cybran Reaver
    all_bps.Unit["xsa0402"].Weapon[1].TargetPriorities = ExtraHeavy_Slow_AntiStructure  -- Seraphim Mega Bomber
    all_bps.Unit["xsa0402"].Weapon[2].TargetPriorities = Medium_AA_Gun                  -- Seraphim Mega Bomber
    all_bps.Unit["xsa0402"].Weapon[3].TargetPriorities = Medium_AA_Gun                  -- Seraphim Mega Bomber
    all_bps.Unit["xsa0402"].Weapon[4].TargetPriorities = Medium_AA_Gun                  -- Seraphim Mega Bomber
    all_bps.Unit["xsa0402"].Weapon[5].TargetPriorities = Medium_AA_Gun                  -- Seraphim Mega Bomber
    all_bps.Unit["ues0401"].Weapon[1].TargetPriorities = Heavy_Torpedo                  -- UEF Atlantis
    all_bps.Unit["ues0401"].Weapon[2].TargetPriorities = Heavy_AA_Missile               -- UEF Atlantis
    all_bps.Unit["ues0401"].Weapon[3].TargetPriorities = Heavy_AA_Missile               -- UEF Atlantis
    all_bps.Unit["ues0401"].Weapon[4].TargetPriorities = Heavy_AA_Missile               -- UEF Atlantis
    all_bps.Unit["ues0401"].Weapon[5].TargetPriorities = Heavy_AA_Missile               -- UEF Atlantis
    all_bps.Unit["uas0401"].Weapon[1].TargetPriorities = Heavy_Naval_Artillery          -- Aeon Tempest
    all_bps.Unit["uas0401"].Weapon[2].TargetPriorities = Heavy_Torpedo                  -- Aeon Tempest


--                                                                                         
--                                 MASS UNIT MODIFICATIONS                                 
--                                                                                         

    for id,bp in pairs(all_bps.Unit) do

        # GET UNIT'S CATEGORIES

        local cats = {}
        for k,cat in pairs(bp.Categories) do
            cats[cat] = true
        end
		
--                                                                                         
--                                      INTEL RANGES                                       
--                                                                                         


        if not cats.EXPERIMENTAL then       -- Allow Experimental unit's blueprint to determine Intel stats.
            if not bp.Intel then
                bp.Intel = {}
            end

--                                         VISION                                          

            if cats.STRUCTURE then
                if cats.ECONOMIC then                                   -- 45 Units
                    bp.Intel.VisionRadius = 5
                elseif cats.FACTORY then                                -- 40 Units + 4 Crab Eggs
                    bp.Intel.VisionRadius = 25
                elseif cats.SHIELD then                                 -- 11 Units
                    bp.Intel.VisionRadius = 5
                elseif cats.ENGINEERSTATION then                        --  5 Units
                    bp.Intel.VisionRadius = 5
                elseif cats.INDIRECTFIRE then                           -- 14 Units
                    bp.Intel.VisionRadius = 10
                elseif cats.NUKE then                                   --  5 Units
                    bp.Intel.VisionRadius = 10
                elseif cats.OPTICS and cats.AEON then                   --  1 Unit
                    bp.Intel.VisionRadius = 10
                elseif cats.ORBITALSYSTEM then                          --  1 Unit
                    bp.Intel.VisionRadius = 10
                elseif cats.DEFENSE and (not cats.BENIGN) then
                    if cats.TECH3 and cats.DIRECTFIRE then              --  1 Unit
                        bp.Intel.VisionRadius = 25
                    else                                                -- 38 Units
                        bp.Intel.VisionRadius = 20
                    end
                elseif cats.INTELLIGENCE and (not cats.OPTICS) then     -- 25 Units
                    bp.Intel.VisionRadius = 5
                elseif cats.AIRSTAGINGPLATFORM then                     --  4 Units
                    bp.Intel.VisionRadius = 5
                end
            elseif cats.LAND then
                if cats.COMMAND then                                    --  4 Units
                    bp.Intel.VisionRadius = 30
                elseif cats.TECH1 then
                    if cats.SCOUT then                                  --  4 Units
                        bp.Intel.VisionRadius = 30
                    elseif cats.LAB then
                        bp.Intel.VisionRadius = 15                      --  3 Units
                    else
                        bp.Intel.VisionRadius = 20                      -- 16 Units
                    end
                elseif cats.TECH2 then
                    if cats.KAMIKAZE then
                        bp.Intel.VisionRadius = 10                      --  1 Unit
                    else
                        bp.Intel.VisionRadius = 20                      -- 26 Units
                    end
                elseif cats.TECH3 then
                    if cats.DIRECTFIRE then                             --  9 Units
                        bp.Intel.VisionRadius = 30
                    elseif cats.SUBCOMMANDER then                       --  4 Units
                        bp.Intel.VisionRadius = 30
                    elseif cats.TELEPORTBEACON then                     -- 1 Unit
                        bp.Intel.VisionRadius = 5
                    else
                        bp.Intel.VisionRadius = 20                      -- 11 Units
                    end
                end
            elseif cats.AIR then
                if cats.SATELLITE then                                  --  1 Unit
                    bp.Intel.VisionRadius = 5
                elseif cats.SCOUT then                                  --  4 Units
                    bp.Intel.VisionRadius = 35
                elseif cats.GROUNDATTACK then                           --  8 Units
                    bp.Intel.VisionRadius = 20
                elseif cats.POD then                                    --  3 Units
                    bp.Intel.VisionRadius = 5
                elseif cats.TECH1 then
                    if cats.TRANSPORTATION then                         --  4 Units
                        bp.Intel.VisionRadius = 20
                    else                                                --  8 Units
                        if not cats.INSIGNIFICANTUNIT then              -- skip Cybran build effects
                            bp.Intel.VisionRadius = 25
                        end
                    end
                elseif cats.KAMIKAZE then                               --  1 Units
                    bp.Intel.VisionRadius = 5
                elseif cats.TECH2 then
                    if cats.ANTINAVY then                               --  4 Units
                        bp.Intel.VisionRadius = 30
                    else                                                --  8 Units
                        bp.Intel.VisionRadius = 25
                    end
                elseif cats.TECH3 then
                    if cats.TRANSPORTATION then                         --  1 Units
                        bp.Intel.VisionRadius = 25
                    elseif cats.INTELLIGENCE then                       --  4 Units
                        bp.Intel.VisionRadius = 75
                    else                                                --  9 Units
                        bp.Intel.VisionRadius = 35
                    end
                end
            elseif cats.NAVAL then
                if cats.TECH1 or cats.TECH2 then                        -- 23 Units
                    bp.Intel.VisionRadius = 30
                elseif cats.TECH3 then
                    if cats.NUKESUB then                                --  3 Units
                        bp.Intel.VisionRadius = 30
                    else                                                --  9 Units
                        bp.Intel.VisionRadius = 40
                    end
                end
            else                                                        --  3 Units
                bp.Intel.VisionRadius = 5
            end

--                                         SONAR                                           

            local RemoveWaterVision = true
            if cats.STRUCTURE then
                if cats.SONAR then
                    if cats.TECH1 then                                  --  4 Units
                        bp.Intel.SonarRadius = 175
                        RemoveWaterVision = false
                    elseif cats.TECH2 then
                        if cats.SERAPHIM then                           --  1 Unit
                            bp.Intel.SonarRadius = 500
                            RemoveWaterVision = false
                        else                                            --  3 Units
                            bp.Intel.SonarRadius = 350
                            RemoveWaterVision = false
                        end
                    elseif cats.TECH3 then                              --  3 Units
                        bp.Intel.SonarRadius = 500
                        RemoveWaterVision = false
                    end
                elseif cats.ANTINAVY then                               --  9 Units
                    bp.Intel.SonarRadius = 30
                    RemoveWaterVision = false
                else                                                    --  All other Structures
                    bp.Intel.SonarRadius = 0
                end
            elseif cats.MOBILESONAR then                                --  3 Unit
                bp.Intel.SonarRadius = 500
                RemoveWaterVision = false
            elseif cats.NAVAL then
                if cats.T1SUBMARINE then                                --  4 Units
                    bp.Intel.SonarRadius = 60
                    bp.Intel.SonarRadiusWhileMoving = 40
                    RemoveWaterVision = false
                elseif cats.ANTISUB then                                --  8 Units
                    bp.Intel.SonarRadius = 90
                    RemoveWaterVision = false
                else                                                    --  All other Ships
                    bp.Intel.SonarRadius = 0
                end
            else                                                        --  All other Units
                bp.Intel.SonarRadius = 0
            end
            if cats.COMMAND or bp.Intel.DefenseSonar then               --  Amphibious land units with torpedoes
                bp.Intel.WaterVisionRadius = bp.Intel.VisionRadius
                RemoveWaterVision = false
            end
            if RemoveWaterVision == true then
                if bp.Intel.WaterVisionRadius then
                    if bp.Intel.WaterVisionRadius > 0 then
                        bp.Intel.WaterVisionRadius = 0
                    end
                end
            else
                if bp.Intel.SonarRadius then
                    if bp.Intel.SonarRadius >= bp.Intel.VisionRadius then
                        bp.Intel.WaterVisionRadius = bp.Intel.VisionRadius * 1.2
                    end
                end
            end

--                                         RADAR                                           

            local RemoveRadar = false
            if cats.STRUCTURE then
                if cats.RADAR then
                    if cats.TECH1 then
                        bp.Intel.RadarRadius = 115
                    elseif cats.TECH2 then
                        bp.Intel.RadarRadius = 230
                    end
                elseif cats.OMNI then
                    bp.Intel.RadarRadius = 600
                else
                    RemoveRadar = true
                end
            elseif cats.LAND then
                if cats.SCOUT then
                    bp.Intel.RadarRadius = 45
                elseif cats.LOYALIST then
                    bp.Intel.RadarRadius = 60
                else
                    RemoveRadar = true
                end
            elseif cats.NAVAL then
                if cats.FRIGATE then
                    bp.Intel.RadarRadius = 50
                elseif cats.T1SUBMARINE then
                    bp.Intel.RadarRadius = 50
                elseif cats.CRUISER then
                    bp.Intel.RadarRadius = 90
                elseif cats.CARRIER then                
                    bp.Intel.RadarRadius = 300
                elseif cats.NUKESUB then                
                    bp.Intel.RadarRadius = 100
                else
                    RemoveRadar = true
                end
            elseif cats.AIR and cats.TECH3 and cats.INTELLIGENCE then
                bp.Intel.RadarRadius = 200
            else
                RemoveRadar = true
            end
            if RemoveRadar == true then
                if bp.Intel.RadarRadius then
                    if bp.Intel.RadarRadius > 0 then
                        bp.Intel.RadarRadius = 0
                    end
                end
            end


        end


--                                                                                         
--                                  TARGETING PRIORITIES                                   
--                                                                                         

        if cats.TECH1 then
            if cats.STRUCTURE then
                if cats.DIRECTFIRE then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = T1_Point_Defense
                    end
                elseif cats.ANTIAIR then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Light_AA_Gun
                    end
                elseif cats.ANTINAVY then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = T1_Torpedo
                    end
                end
            elseif cats.LAND then
                if cats.INTELLIGENCE then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Scout
                    end
                elseif cats.LAB then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Light_Attack_Bot
                    end
                elseif cats.DIRECTFIRE then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Medium_Assault_Unit
                    end
                elseif cats.ARTILLERY then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Light_Slow_AntiStructure
                    end
                elseif cats.ANTIAIR then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Light_AA_Gun
                    end
                end
            elseif cats.AIR then
                if cats.ANTIAIR then
                    if cats.AEON or cats.CYBRAN then
                        if bp.Weapon[1] and bp.Weapon[2] then
                            bp.Weapon[1].TargetPriorities = Light_AA_Gun
                            bp.Weapon[2].TargetPriorities = Light_AA_Gun
                        end
                    else
                        if bp.Weapon[1] then
                            bp.Weapon[1].TargetPriorities = Light_AA_Gun
                        end
                    end
                elseif cats.BOMBER then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Light_Slow_AntiStructure
                    end
                elseif cats.GROUNDATTACK then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Light_Attack_Bot
                    end
                end
            elseif cats.NAVAL then
                if cats.ANTIAIR then
                    if cats.LIGHTBOAT then               -- Aeon AA Boat
                        if bp.Weapon[1] then
                            bp.Weapon[1].TargetPriorities = Light_AA_Gun
                        end
                    else                            -- UEF, Cybran, and Seraphim Frigates
                        if bp.Weapon[1] and bp.Weapon[2] then
                            bp.Weapon[1].TargetPriorities = Light_Naval_Cannon
                            bp.Weapon[2].TargetPriorities = Light_AA_Gun
                        end
                    end
                elseif cats.FRIGATE then            -- Aeon Frigate
                    if bp.Weapon[1] and bp.Weapon[2] then
                        bp.Weapon[1].TargetPriorities = Light_Naval_Cannon
                        bp.Weapon[2].TargetPriorities = Light_Naval_Cannon
                    end
                elseif cats.T1SUBMARINE then
                    if bp.Weapon[1] then            -- All 4 subs
                        bp.Weapon[1].TargetPriorities = T1_Torpedo
                    end
                    if bp.Weapon[3] then            -- Seraphim sub has gun as #3
                        bp.Weapon[3].TargetPriorities = Light_NonNaval_Ship_Cannon
                    elseif bp.Weapon[2] then        -- UEF and Cybran subs have gun as #2
                        bp.Weapon[2].TargetPriorities = Light_NonNaval_Ship_Cannon
                    end
                end
            end
        elseif cats.TECH2 then
            if cats.STRUCTURE then
                if cats.ANTIAIR then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Flak
                    end
                elseif cats.ANTINAVY then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Heavy_Torpedo
                    end
                elseif cats.DIRECTFIRE then
                    if cats.AEON or cats.UEF then
                        if bp.Weapon[1] then
                            bp.Weapon[1].TargetPriorities = Slow_T2PD
                        end
                    else
                        if bp.Weapon[1] then
                            bp.Weapon[1].TargetPriorities = Fast_T2PD
                        end
                    end
                elseif cats.ARTILLERY then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Long_Range_Artillery
                    end
                end
            elseif cats.LAND then
                if cats.ANTIAIR then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Flak
                    end
                elseif cats.INDIRECTFIRE then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Heavy_Slow_AntiStructure
                    end
                elseif cats.FIELDENGINEER then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Light_Attack_Bot
                    end
                elseif cats.DIRECTFIRE then
                    if bp.Weapon then
                        for k,v in pairs(bp.Weapon) do
                            local GroundWeapon = false
                            local Torpedo = false
                            if v.FireTargetLayerCapsTable then
                                for k2,v2 in pairs(v.FireTargetLayerCapsTable) do
                                    if v2 == 'Land|Water|Seabed' then
                                        GroundWeapon = true
                                        break
                                    elseif v2 == 'Seabed|Sub|Water' then        -- Wagner Torpedo
                                        Torpedo = true
                                        break
                                    end
                                end
                            end
                            if GroundWeapon == true then
                                v.TargetPriorities = Heavy_Assault_Unit
                            elseif Torpedo == true then
                                v.TargetPriorities = T1_Torpedo
                            end
                        end
                    end
                end
            elseif cats.AIR then
                if cats.TRANSPORTATION then
                    if cats.AEON then
                        if bp.Weapon[1] and bp.Weapon[2] and bp.Weapon[3] and bp.Weapon[4] then
                            bp.Weapon[1].TargetPriorities = Transport_AA_Gun
                            bp.Weapon[2].TargetPriorities = Transport_AA_Gun
                            bp.Weapon[3].TargetPriorities = Transport_AA_Gun
                            bp.Weapon[4].TargetPriorities = Transport_AA_Gun
                        end
                    elseif cats.UEF then
                        if bp.Weapon[1] and bp.Weapon[2] and bp.Weapon[3] and bp.Weapon[4] then
                            bp.Weapon[1].TargetPriorities = Light_Attack_Bot
                            bp.Weapon[2].TargetPriorities = Light_Attack_Bot
                            bp.Weapon[3].TargetPriorities = Transport_AA_Gun
                            bp.Weapon[4].TargetPriorities = Transport_AA_Gun
                        end
                    elseif cats.CYBRAN then
                        if bp.Weapon[1] and bp.Weapon[2] then
                            bp.Weapon[1].TargetPriorities = Light_Attack_Bot
                            bp.Weapon[2].TargetPriorities = Transport_AA_Gun
                        end
                    elseif cats.SERAPHIM then
                        if bp.Weapon[1] and bp.Weapon[2] and bp.Weapon[3] then
                            bp.Weapon[1].TargetPriorities = Transport_AA_Gun
                            bp.Weapon[2].TargetPriorities = Transport_AA_Gun
                            bp.Weapon[3].TargetPriorities = Light_Attack_Bot
                        end
                    end
                elseif cats.ANTINAVY then   -- Torpedo Bombers
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = T1_Torpedo
                    end
                elseif cats.BOMBER then     -- Fighter/Bombers
                    if bp.Weapon then
                        for k,v in pairs(bp.Weapon) do
                            local GroundWeapon = false
                            local AAWeapon = false
                            if v.FireTargetLayerCapsTable then
                                for k2,v2 in pairs(v.FireTargetLayerCapsTable) do
                                    if v2 == 'Air|Land' then
                                        AAWeapon = true
                                        break
                                    elseif v2 == 'Land|Seabed|Water' then        -- Wagner Torpedo
                                        GroundWeapon = true
                                        break
                                    end
                                end
                            end
                            if GroundWeapon == true then
                                v.TargetPriorities = Heavy_Slow_AntiStructure
                            elseif AAWeapon == true then
                                v.TargetPriorities = Medium_AA_Gun
                            end
                        end
                    end
                elseif cats.GROUNDATTACK then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Heavy_Assault_Unit
                    end
                    if bp.Weapon[2] then
                        bp.Weapon[2].TargetPriorities = Heavy_Assault_Unit
                    end
                elseif cats.ANTIAIR then
                    if cats.AEON then
                        if bp.Weapon[1] then
                            bp.Weapon[1].TargetPriorities = Medium_AA_Gun
                        end
                    end
                end
            elseif cats.NAVAL then
                if cats.DESTROYER then
                    if bp.Weapon then
                        for k,v in pairs(bp.Weapon) do
                            local NavalCannon = false
                            local AAWeapon = false
                            local Torpedo = false
                            if v.FireTargetLayerCapsTable then
                                for k2,v2 in pairs(v.FireTargetLayerCapsTable) do
                                    if v2 == 'Air' then
                                        AAWeapon = true
                                        break
                                    elseif v2 == 'Land|Water|Seabed' then
                                        NavalCannon = true
                                        break
                                    elseif v2 == 'Seabed|Sub' then
                                        Torpedo = true
                                        break
                                    elseif v2 == 'Seabed|Sub|Water' then
                                        Torpedo = true
                                        break
                                    end
                                end
                            end
                            if NavalCannon == true then
                                v.TargetPriorities = Heavy_Naval_Cannon
                            elseif AAWeapon == true then
                                v.TargetPriorities = Medium_AA_Gun
                            elseif Torpedo == true then
                                v.TargetPriorities = AntiSub
                            end
                        end
                    end
                elseif cats.CRUISER then
                    if bp.Weapon then
                        if cats.AEON then
                            bp.Weapon[1].TargetPriorities = Light_NonNaval_Ship_Cannon
                            bp.Weapon[2].TargetPriorities = Cruiser_AA
                            bp.Weapon[3].TargetPriorities = Cruiser_AA
                        elseif cats.UEF then
                            bp.Weapon[1].TargetPriorities = Long_Range_Artillery
                            bp.Weapon[2].TargetPriorities = Light_NonNaval_Ship_Cannon
                            bp.Weapon[3].TargetPriorities = Cruiser_AA
                        elseif cats.CYBRAN then
                            bp.Weapon[1].TargetPriorities = Light_NonNaval_Ship_Cannon
                            bp.Weapon[2].TargetPriorities = Cruiser_AA
                        elseif cats.SERAPHIM then
                            bp.Weapon[1].TargetPriorities = Long_Range_Artillery
                            bp.Weapon[2].TargetPriorities = Flak
                            bp.Weapon[3].TargetPriorities = Cruiser_AA
                        end
                    end
                elseif cats.LIGHTBOAT then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = AntiSub
                    end
                end
            end
        elseif cats.TECH3 then
            if cats.STRUCTURE then
                if cats.ANTIAIR then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Heavy_AA_Missile
                    end
                elseif cats.ANTINAVY then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Heavy_Torpedo
                    end
                elseif cats.ARTILLERY then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Long_Range_Artillery
                    end
                elseif cats.DIRECTFIRE then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Slow_T2PD
                    end
                end
            elseif cats.LAND then
                if cats.SUBCOMMANDER then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Heavy_Assault_Unit
                    end
                    if bp.Weapon[2] then                                -- Cybran AA Missile Upgrade
                        bp.Weapon[2].TargetPriorities = Light_AA_Gun
                    end
                elseif cats.ARTILLERY then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Long_Range_Artillery
                    end
                elseif cats.INDIRECTFIRE then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Long_Range_Artillery
                    end
                end
            elseif cats.AIR then
                if cats.ANTIAIR then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Heavy_AA_Missile
                    end
                    if cats.UEF or cats.CYBRAN then
                        if bp.Weapon[2] then
                            bp.Weapon[2].TargetPriorities = Heavy_AA_Missile
                        end
                    end
                elseif cats.ANTINAVY then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Heavy_Torpedo
                    end
                elseif cats.BOMBER then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = ExtraHeavy_Slow_AntiStructure
                    end
                elseif cats.GROUNDATTACK then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Extreme_Assault_FastReload
                    end
                    if bp.Weapon[2] then
                        bp.Weapon[2].TargetPriorities = Transport_AA_Gun
                    end
                    if cats.AEON then
                        if bp.Weapon[3] then
                            bp.Weapon[3].TargetPriorities = Transport_AA_Gun
                        end
                    end
                elseif cats.TRANSPORTATION then
                    if bp.Weapon[1] and bp.Weapon[2] then
                        bp.Weapon[1].TargetPriorities = Heavy_Assault_Unit
                        bp.Weapon[2].TargetPriorities = Heavy_Assault_Unit
                    end
                    if bp.Weapon[3] and bp.Weapon[4] and bp.Weapon[5] and bp.Weapon[6] then
                        bp.Weapon[3].TargetPriorities = Transport_AA_Gun
                        bp.Weapon[4].TargetPriorities = Transport_AA_Gun
                        bp.Weapon[5].TargetPriorities = Transport_AA_Gun
                        bp.Weapon[6].TargetPriorities = Transport_AA_Gun
                    end
                end
            elseif cats.NAVAL then
                if cats.CARRIER then
                    if cats.SERAPHIM then
                        if bp.Weapon[1] then
                            bp.Weapon[1].TargetPriorities = Long_Range_Artillery
                        end
                        if bp.Weapon[2] then
                            bp.Weapon[2].TargetPriorities = Carrier_AA
                        end
                        if bp.Weapon[3] then
                            bp.Weapon[3].TargetPriorities = Carrier_AA
                        end
                    else
                        if bp.Weapon[1] then
                            bp.Weapon[1].TargetPriorities = Carrier_AA
                        end
                        if bp.Weapon[2] then
                            bp.Weapon[2].TargetPriorities = Carrier_AA
                        end
                        if cats.CYBRAN then
                            if bp.Weapon[3] then
                                bp.Weapon[3].TargetPriorities = Carrier_AA
                            end
                            if bp.Weapon[4] then
                                bp.Weapon[4].TargetPriorities = Carrier_AA
                            end
                        end
                    end
                elseif cats.NUKESUB then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = Long_Range_Artillery
                    end
                    if cats.CYBRAN then
                        if bp.Weapon[2] then
                            bp.Weapon[2].TargetPriorities = AntiSub
                        end
                    end
                elseif cats.MISSILESHIP then
                    if bp.Weapon[1] and bp.Weapon[2] then
                        bp.Weapon[1].TargetPriorities = Long_Range_Artillery
                        bp.Weapon[2].TargetPriorities = Long_Range_Artillery
                    end
                elseif cats.SUBHUNTER then
                    if bp.Weapon[1] then
                        bp.Weapon[1].TargetPriorities = AntiSub
                    end
                    if cats.SERAPHIM then
                        if bp.Weapon[4] then
                            bp.Weapon[4].TargetPriorities = Cruiser_AA
                        end
                    end
                end
            end
        end


--                                                                                         
--                                       ABILITIES                                         
--                                                                                         

        if bp.Display then
            Abilities = {}
            if cats.FACTORY then
                table.insert(Abilities,'<LOC ability_factory>')
                if cats.TECH1 or cats.TECH2 then
                    table.insert(Abilities,'<LOC ability_upgradable>')
                end
            elseif cats.ENERGYPRODUCTION then
                table.insert(Abilities,'<LOC ability_powerplant>')
            end
            if Abilities[1] then
                bp.Display.Abilities = Abilities
            end
        end

--                                                                                         
--                                  MISCELANEOUS CHANGES                                   
--                                                                                         


    # Unlimited Units

        if cats.General then
            cats.General.CapCost = 0
        end

    # Larger Ships

        if cats.NAVAL then
            if cats.MOBILE and (not cats.SHIELD) then
                local MultiplierConstant = 0
                if cats.TECH1 then
                    MultiplierConstant = 1.5
                elseif cats.TECH2 then
                    MultiplierConstant = 1.75
                elseif cats.TECH3 then
                    if cats.CARRIER then
                        MultiplierConstant = 1
                    else
                        MultiplierConstant = 1.75
                    end
                elseif cats.EXPERIMENTAL then
                    MultiplierConstant = 1.35
                end                
                if bp.Display.UniformScale then
                    bp.Display.UniformScale = bp.Display.UniformScale * MultiplierConstant
                end
                if bp.Footprint.SizeX then
                    bp.Footprint.SizeX = math.ceil(bp.Footprint.SizeX * MultiplierConstant)
                    bp.Footprint.SizeZ = math.ceil(bp.Footprint.SizeZ * MultiplierConstant)
                end
                bp.SelectionSizeX = bp.SelectionSizeX * MultiplierConstant
                bp.SelectionSizeZ = bp.SelectionSizeZ * MultiplierConstant
                --bp.SelectionThickness = bp.SelectionThickness * 1.25
                if bp.SizeX then
                    bp.SizeX = bp.SizeX * MultiplierConstant
                    bp.SizeY = bp.SizeY * MultiplierConstant
                    bp.SizeZ = bp.SizeZ * MultiplierConstant
                end
                if bp.Display.AnimationWalkRate then
                    bp.Display.AnimationWalkRate = bp.Display.AnimationWalkRate / MultiplierConstant
                end
            elseif cats.FACTORY then
                if bp.Display.UniformScale then
                    bp.Display.UniformScale = bp.Display.UniformScale * 1.75
                end
                if bp.Footprint.SizeX then
                    bp.Footprint.SizeX = bp.Footprint.SizeX * 1.75
                    bp.Footprint.SizeZ = bp.Footprint.SizeZ * 1.75
                end
                bp.SelectionSizeX = bp.SelectionSizeX * 1.75
                bp.SelectionSizeZ = bp.SelectionSizeZ * 1.75
                --bp.SelectionThickness = bp.SelectionThickness * 1.25
                if bp.SizeX then
                    bp.SizeX = bp.SizeX * 1.75
                    bp.SizeY = bp.SizeY * 1.75
                    bp.SizeZ = bp.SizeZ * 1.75
                end
            end
        end


    # Remove fuel usage completely from game. Replaced with Ammunition restrictions for planes.

        if bp.Physics.FuelRechargeRate then
            bp.Physics.FuelRechargeRate = nil
        end
        if bp.Physics.FuelUseTime then
            bp.Physics.FuelUseTime = nil
        end
        if cats.FACTORY and cats.AIR then
            if not bp.AI then
                bp.AI = {}
            end
            if cats.TECH1 then
                bp.AI.AirStagingRange = 100
                bp.AI.GuardScanRadius = 100
                bp.AI.StagingPlatformScanRadius = 100
            elseif cats.TECH2 then
                bp.AI.AirStagingRange = 200
                bp.AI.GuardScanRadius = 200
                bp.AI.StagingPlatformScanRadius = 200
            elseif cats.TECH3 then
                bp.AI.AirStagingRange = 300
                bp.AI.GuardScanRadius = 300
                bp.AI.StagingPlatformScanRadius = 300
            end
            if not cats.OVERLAYMISC then
                table.insert(bp.Categories, "OVERLAYMISC")
            end
        elseif cats.AIRSTAGINGPLATFORM then
            if cats.CRUISER or cats.LAND then
                bp.AI.AirStagingRange = 90
                bp.AI.GuardScanRadius = 90
                bp.AI.StagingPlatformScanRadius = 90
            else
                bp.AI.AirStagingRange = 300
                bp.AI.GuardScanRadius = 300
                bp.AI.StagingPlatformScanRadius = 300
            end
        end


    # Transport fuel - remove fuel usage

        --if cats.TRANSPORTATION and (not cats.GROUNDATTACK) then
        --    bp.Physics.FuelRechargeRate = nil
        --    bp.Physics.FuelUseTime = nil
        --end

    # Aircraft Armor (so Flak doesn't damage anything but aircraft)
        if cats.AIR and cats.MOBILE then
            if bp.Defense then
                if bp.Defense.ArmorType then
                    if bp.Defense.ArmorType != 'Gunship' then
                        if bp.Defense.ArmorType != 'Bomber' then
                            if bp.Defense.ArmorType != 'Scout' then
                                if bp.Defense.ArmorType != 'ASF' then
                                    bp.Defense.ArmorType = 'NormalAircraft'
                                end
                            end
                        end
                    end
                end
            end
        end

    # Capture Rates:
    # 
    # Cybran high tech engineers can capture faster than other factions.
    # Other T1 Engineers capture too slow due to reduced build rate.
        if cats.ENGINEER then
            if bp.Economy then
                if cats.COMMAND then
                    bp.Economy.CaptureRate = 10
                elseif cats.CYBRAN then
                    if cats.ENGINEERSTATION then
                        if cats.TECH1 then
                            bp.Economy.CaptureRate = 20
                        elseif cats.TECH2 then
                            bp.Economy.CaptureRate = 15
                        else
                            bp.Economy.CaptureRate = 10
                        end
                    elseif cats.TECH1 then
                        bp.Economy.CaptureRate = 25      -- Compensates for very low build rate for T1
                    else
                        bp.Economy.CaptureRate = 10
                    end
                elseif cats.TECH1 then
                    bp.Economy.CaptureRate = 10          -- Compensates for very low build rate for T1
                end
            end
        end

    # Hovercraft should be sonar stealth
        if bp.Physics.MotionType == 'RULEUMT_Hover' then
            bp.Intel.SonarStealth = true
        end

    # Strategic Icon Fade
    #
    # Alters the point where the strategic icons show up depending on the size of the unit.
    
        if bp.SelectionSizeX and bp.SelectionSizeZ and bp.Display then
            if bp.Display.Mesh then
                if bp.Display.Mesh.IconFadeInZoom then
                    local UnitSelectionSize = math.sqrt(bp.SelectionSizeX * bp.SelectionSizeZ)

                    if cats.SATELLITE then
                        bp.Display.Mesh.IconFadeInZoom = math.floor(UnitSelectionSize * 200)
                    elseif cats.BENIGN then
                        bp.Display.Mesh.IconFadeInZoom = 5000
                    elseif cats.AEON and cats.AIR and cats.EXPERIMENTAL then
                        bp.Display.Mesh.IconFadeInZoom = math.floor(UnitSelectionSize * 200)
                    elseif UnitSelectionSize < 2 then
                        if cats.STRUCTURE then
                            bp.Display.Mesh.IconFadeInZoom = math.floor(UnitSelectionSize * 150)
                        else
                            bp.Display.Mesh.IconFadeInZoom = math.floor(UnitSelectionSize * 125)
                        end                        
                    --elseif UnitSelectionSize < 10 then
                    else
                        bp.Display.Mesh.IconFadeInZoom = math.floor(UnitSelectionSize * 90)
                    end

                    if bp.Display.Mesh.LODs then
                        if bp.Display.Mesh.LODs[1] then
                            if bp.Display.Mesh.LODs[2] then
                                bp.Display.Mesh.LODs[1].LODCutoff = math.floor(bp.Display.Mesh.IconFadeInZoom)
                            else
                                bp.Display.Mesh.LODs[1].LODCutoff = math.floor(bp.Display.Mesh.IconFadeInZoom * 6)
                            end
                        end
                        if bp.Display.Mesh.LODs[2] then
                            bp.Display.Mesh.LODs[2].LODCutoff = math.floor(bp.Display.Mesh.IconFadeInZoom * 6)
                        end
                    end
                end
            end
        end

    # Ship Wreckage
    # 
    # Part of the alteration which allows ship wreckage to stay on the seabed.

        if cats.NAVAL then
            if not bp.Wreckage then
                LOG("Adding wreckage information to ", bp.Description)
                bp.Wreckage = {
                    Blueprint = '/props/DefaultWreckage/DefaultWreckage_prop.bp',
                    EnergyMult = 0,
                    HealthMult = 0.9,
                    MassMult = 0.9,
                    ReclaimTimeMultiplier = 1,
                    WreckageLayers = {
                        Air = false,
                        Land = false,
                        Seabed = true,
                        Sub = true,
                        Water = true,
                    };
                }
            else
                LOG("Updating WreckageLayers for ", bp.Description)
                local wl = bp.Wreckage.WreckageLayers
                wl.Seabed = true
                wl.Sub = true
                wl.Water = true
            end
        end


    # Cliffhanger Modification
    #
    # Allows structures to be built on much rougher terrain.

        if cats.STRUCTURE then
            bp.Physics.MaxGroundVariation = 1.6
        end


    # Free Regen
    #
    # A small amount of regen has been added to simulate field repairs on units.
    # It should have no impact on battle outcomes, but units just sitting around a long time will eventually repair.
    # This also calculated the amount of regen Seraphim units have, which is combat armor and stays on constantly.
    
        local MinimumRegenRate = 0
        if cats.SERAPHIM then
            if cats.ENGINEER then
                MinimumRegenRate = math.max(2,math.min(bp.Defense.MaxHealth * .005,30))
            elseif cats.MOBILE then
                if cats.LAND then
                    MinimumRegenRate = math.max(30,math.min(bp.Defense.MaxHealth * .03,200))
                elseif cats.NAVAL then
                    MinimumRegenRate = math.max(15,math.min(bp.Defense.MaxHealth * .013,250))
                elseif cats.AIR then
                    MinimumRegenRate = math.max(1,math.min(bp.Defense.MaxHealth * .005,10))
                end
            else
                MinimumRegenRate = math.max(2,math.min(bp.Defense.MaxHealth * .002,50))
            end
            bp.Defense.RegenRate = MinimumRegenRate
        else
            MinimumRegenRate = math.max(2,math.min(bp.Defense.MaxHealth * .002,50))
            bp.Defense.SelfRepairRate = MinimumRegenRate
        end



    # Escalation Slowdown
    #
    # This change makes the build times of all factory-built units go along with the new faster factory build rates.
    # The purpose of the factory adjustment was to bring factories in general a step above engineers in terms of build
    # rate, so that engineer assistance would not have such a major impact on how fast factories produce units.
        if cats.MOBILE then
            if bp.Economy.BuildTime then
                if cats.ENGINEER then
                else
                    if cats.EXPERIMENTAL then
                    else
                        if cats.TECH1 then
                            bp.Economy.BuildTime = bp.Economy.BuildTime * 2     -- T1 Factory built units except engineers
                        elseif cats.TECH2 then
                            bp.Economy.BuildTime = bp.Economy.BuildTime * 2     -- T2 Factory built units except engineers
                        elseif cats.TECH3 then
                            bp.Economy.BuildTime = bp.Economy.BuildTime * 2     -- T3 Factory built units except engineers
                        end
                    end
                end
            end
        end


    # Resource Storage Reassignment
    # 
    # Make storage in ACU and designated storage structures ONLY.

        if not (cats.MASSSTORAGE or cats.ENERGYSTORAGE or cats.COMMAND) then
            if bp.Economy.StorageEnergy then
                bp.Economy.StorageEnergy = 0
            end
            if bp.Economy.StorageMass then
                bp.Economy.StorageMass = 0
            end
        end


    # Land unit acceleration
    #
    # Fix to make land units more responsive.
    
        if cats.LAND and cats.MOBILE then -- and (not cats.COMMAND) and (not cats.EXPERIMENTAL) then
            if bp.Physics.MaxAcceleration then
                bp.Physics.MaxAcceleration = 20
                --if cats.BOT then
                --    bp.Physics.MaxAcceleration = 20
                --else
                --    bp.Physics.MaxAcceleration = 10
                --end
            end
        end


    # Ship Sink Speed
    # 
    # Make ships sink slower.

        if cats.NAVAL and cats.MOBILE then  
            if bp.Display.AnimationDeath then
                for k,Anim in pairs(bp.Display.AnimationDeath) do
                    if cats.TECH1 then
                        bp.Display.AnimationDeath[k].AnimationRateMax = 0.8
                        bp.Display.AnimationDeath[k].AnimationRateMin = 0.6
                    elseif cats.TECH2 then
                        bp.Display.AnimationDeath[k].AnimationRateMax = 0.5
                        bp.Display.AnimationDeath[k].AnimationRateMin = 0.3
                    elseif cats.TECH3 then
                        bp.Display.AnimationDeath[k].AnimationRateMax = 0.3
                        bp.Display.AnimationDeath[k].AnimationRateMin = 0.2
                    end
                end
            end
        end


--[[
    # Aircraft Fuel
    # 
    # Make planes run out of fuel at specific rates relative to original game

        local FuelMultiplier = 1
        if cats.AIR then
            if cats.ANTIAIR and (cats.TECH1 or cats.TECH3) then  # Excludes T2 gunships which are AA
                FuelMultiplier = .5
            elseif cats.BOMBER then
                FuelMultiplier = .3
            elseif cats.TRANSPORTATION and not cats.GROUNDATTACK then
                FuelMultiplier = 2
            elseif cats.GROUNDATTACK and (cats.TECH2 or cats.TECH3) then  # Excludes Experimental gunships
                FuelMultiplier = .3
            elseif cats.ANTINAVY then
                FuelMultiplier = .3
            elseif cats.EXPERIMENTAL then
                FuelMultiplier = 10
            end
            if cats.TRANSPORTATION and not cats.GROUNDATTACK then
                if cats.TECH1 then
                    bp.Defense.RegenRate = 10
                elseif cats.TECH2 then
                    bp.Defense.RegenRate = 25
                end
            end
            if bp.Physics.FuelUseTime then
                bp.Physics.FuelUseTime = bp.Physics.FuelUseTime * FuelMultiplier
            end
        end
--]]




    # Expanded Tarmacs      **Reverted**
    # 
    # Make UEF and Cybran tarmacs bigger.
        if cats.UEF then
            if bp.Display.Tarmacs then
                bp.Display.Tarmacs[1].Length = bp.Display.Tarmacs[1].Length * 2
                bp.Display.Tarmacs[1].Width = bp.Display.Tarmacs[1].Width * 2
                bp.Display.Tarmacs[1].FadeOut = 900
            end
        end

    # Nix Omni
    # 
    # Removes Omni from the game.

        if bp.Intel.OmniRadius then
            if not bp.Intel.RadarRadius then
                bp.Intel.RadarRadius = bp.Intel.OmniRadius
            end
            bp.Intel.OmniRadius = 0
        end


    # Upgrade Build Times
    # 
    # This is an attempt to standardize the rate which resources are consumed for ACU/SCU upgrades.
    # The factors may be adjusted as necessary to taste upon playtesting.
    # Mass =     0-500:     10 mass/sec
    # Mass =   500-2000:    25 mass/sec
    # Mass =  2000-25000:   50 mass/sec
    # Mass = 25000 and up: 250 mass/sec

        if bp.Enhancements then
            for EnhancementName,ThisEnhancement in pairs(bp.Enhancements) do
                if bp.Enhancements[EnhancementName].BuildCostMass then
                    if bp.Enhancements[EnhancementName].BuildCostMass <= 2 then
                        bp.Enhancements[EnhancementName].BuildTime = 0.1              -- For Enhancement Removals
                    elseif bp.Enhancements[EnhancementName].BuildCostMass <= 500 then
                        bp.Enhancements[EnhancementName].BuildTime = bp.Enhancements[EnhancementName].BuildCostMass / .333333
                    elseif bp.Enhancements[EnhancementName].BuildCostMass <= 2000 then
                        bp.Enhancements[EnhancementName].BuildTime = bp.Enhancements[EnhancementName].BuildCostMass / .833333
                    elseif bp.Enhancements[EnhancementName].BuildCostMass >= 25000 then
                        bp.Enhancements[EnhancementName].BuildTime = bp.Enhancements[EnhancementName].BuildCostMass / 8.333333
                    else
                        bp.Enhancements[EnhancementName].BuildTime = bp.Enhancements[EnhancementName].BuildCostMass / 1.666667
                    end
                end
            end
        end



    # Node Teleport Enabling
    # This gives teleporting to ALL units in the game but does not enable the actual teleport button.
    # It only sets up the cost for teleporting, and the recharge delay.
    # It only does this for units which are not already set up for teleporting.
        if cats.MOBILE then
            local NaturalTeleporter = false
            if bp.General.CommandCaps.RULEUCC_Teleport then
                if bp.General.CommandCaps.RULEUCC_Teleport == true then
                    NaturalTeleporter = true
                    bp.Physics.NaturalTeleporter = true
                end
            end
            if NaturalTeleporter == false then
                bp.Physics.NaturalTeleporter = false
            end
            bp.Economy.TeleportMassMod = 0
            bp.Economy.TeleportTimeMod = 0
            if cats.NAVAL then
                if cats.EXPERIMENTAL or cats.TECH3 then
                    bp.Economy.TeleportEnergyMod = 25000 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 300
                elseif cats.TECH2 then
                    bp.Economy.TeleportEnergyMod = 5000 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 60
                elseif cats.TECH1 then
                    bp.Economy.TeleportEnergyMod = 1000 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 60
                end
            else
                if cats.COMMAND then
                    bp.Economy.TeleportEnergyMod = 15000 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 60
                elseif cats.SUBCOMMANDER then
                    bp.Economy.TeleportEnergyMod = 5000 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 5
                elseif cats.EXPERIMENTAL then
                    bp.Economy.TeleportEnergyMod = 25000 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 300
                elseif cats.TECH3 then
                    if bp.BlueprintId == "ual0303" then
                        bp.Economy.TeleportEnergyMod = 1000 / bp.Economy.BuildCostEnergy
                        bp.Physics.TeleportRechargeTime = 60
                    else
                        bp.Economy.TeleportEnergyMod = 5000 / bp.Economy.BuildCostEnergy
                        bp.Physics.TeleportRechargeTime = 60
                    end
                elseif cats.TECH2 then
                    bp.Economy.TeleportEnergyMod = 1000 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 60
                elseif cats.TECH1 then
                    bp.Economy.TeleportEnergyMod = 200 / bp.Economy.BuildCostEnergy
                    bp.Physics.TeleportRechargeTime = 15
                end
            end
        end


    # Cloak Mesh enabling


        local meshid = bp.Display.MeshBlueprint
        if meshid then
            local meshbp = original_blueprints.Mesh[meshid]
            if meshbp then
                local shadername = 'UnitFormationPreview'
                local cloakmeshbp = table.deepcopy(meshbp)
                if cloakmeshbp.LODs then
                    for i,lod in cloakmeshbp.LODs do
                        lod.ShaderName = shadername
                    end
                end
                cloakmeshbp.BlueprintId = meshid .. '_cloak'
                bp.Display.CloakMeshBlueprint = cloakmeshbp.BlueprintId
                MeshBlueprint(cloakmeshbp)
            end
        end



--                                                                                         
--                                  VETERANCY ADJUSTMENT                                   
--                                                                                         

   --[[ No longer need this - leftover from before.
    #parameters for customisation
    local scalling = (1/2)
    local evenkills = 4
    
    #base values calculated from cost to compare
    #t1(Mantis)=64  t2(Rhino)= 238 t3(Loyalist)=603 Monkeylord=17480
    local ACUbaseValue = 750 
    local SCUbaseValue = 1100  #11k if calculated by cost
 
    
    if bp.Defense.RegenRate == nil then
        bp.Defense.RegenRate = 0
    end
--    local RegenMod = 0.7*(50 - 1 / (0.00000060257 * bp.Defense.MaxHealth + 0.020016))
--    bp.Defense.RegenRate = bp.Defense.RegenRate + RegenMod

    local regenVal
    if bp.Buffs and bp.Buffs.Regen and bp.Buffs.Regen.Level1 then
        regenVal = bp.Buffs.Regen.Level1
    else
        regenVal = 1
    end

    if not bp.Buffs then
        bp.Buffs = {}
    end

    if not bp.Buffs.Any then
        bp.Buffs.Any = {}
    end

    if not bp.Buffs.Any.VETERANCYREGEN then
        bp.Buffs.Any.VETERANCYREGEN = {
            Stacks = 'ALWAYS',
            Duration = -1,
            Affects = {
                SelfRepair = {
                    Add = regenVal,
                    Mult = 1,
                },
            },
        }
    end

    # Override for ACUs and SCUs
    if bp.Economy and not bp.Economy.xpBaseValue and bp.Economy.BuildCostMass and bp.Economy.BuildCostEnergy and bp.Economy.BuildTime and table.find(bp.Categories,'COMMAND') then
        bp.Economy.xpBaseValue = ACUbaseValue
    end
    if bp.Economy and not bp.Economy.xpBaseValue and bp.Economy.BuildCostMass and bp.Economy.BuildCostEnergy and bp.Economy.BuildTime and table.find(bp.Categories,'SUBCOMMANDER') then
        bp.Economy.xpBaseValue = SCUbaseValue
    end

    #calculate xp depending on xpBaseValue of from cost if no base value is set.
    #old values are not overwriten
    if bp.Economy and not bp.Economy.xpValue and bp.Economy.BuildCostMass and bp.Economy.BuildCostEnergy and bp.Economy.BuildTime and (not table.find(bp.Categories,'UNTARGETABLE') or bp.Economy.xpBaseValue) then
        bp.Economy.xpValue = math.pow((bp.Economy.xpBaseValue or (bp.Economy.BuildCostMass + bp.Economy.BuildCostEnergy/200 + bp.Economy.BuildTime/25)),scalling)
        #if bp.Description then LOG(bp.Description .. ' ' .. bp.Economy.xpValue) end
    end

    #calculate xp per level dependind on own value and kills per level set.
    if bp.Economy and not bp.Economy.XPperLevel and bp.Economy.xpValue then 
        bp.Economy.XPperLevel = bp.Economy.xpValue * evenkills
    end
    if bp.Economy and bp.Defense and not bp.Economy.xpPerHp and bp.Economy.xpValue and bp.Defense.MaxHealth then 
        bp.Economy.xpPerHp = bp.Economy.xpValue / bp.Defense.MaxHealth
    end
        --]]




    # This brings unit veterancy to an attainable level.
    # This also adds a rough DPS value to each tech level.

        --if bp.Veteran then
            #Standardize levels. Level value = # of seconds in combat
            --bp.Veteran = { Level1 = 20, Level2 = 40, Level3 = 80, Level4 = 130, Level5 = 250 }
            -- Turns vet off:  --bp.Veteran = { Level1 = 10000, Level2 = 20000, Level3 = 40000, Level4 = 80000, Level5 = 160000 }

            if not bp.dps then
                bp.dps = 100000                                     -- This makes anything not covered by a category take a very long time to level up.
                if cats.COMMAND then                                -- ACU
                    bp.dps = 750
                elseif cats.SUBCOMMANDER then                       -- Combat Engineers
                    bp.dps = 150
                elseif cats.ENGINEER then
                    bp.dps = 100                                    -- Regular engineers
                elseif cats.FACTORY then
                    if cats.TECH1 then
                        bp.dps = 100
                    elseif cats.TECH2 then
                        bp.dps = 1000
                    elseif cats.TECH3 then
                        bp.dps = 5000
                    else
                        bp.dps = 5000
                    end
                elseif cats.TECH1 then
                    if cats.LAND then
                        if cats.LAB then                            -- LAB
                            bp.dps = 15
                        elseif cats.SCOUT then                      -- Land Scouts
                            bp.dps = 0.5
                        elseif cats.DIRECTFIRE then                 -- Light Tanks
                            bp.dps = 25
                        elseif cats.ARTILLERY then                  -- Light Mobile Artillery
                            bp.dps = 85
                        elseif cats.ANTIAIR then                    -- Light Mobile AA
                            bp.dps = 10
                        end
                    elseif cats.NAVAL then
                        if cats.T1SUBMARINE then                    -- Subs
                            bp.dps = 150
                        elseif cats.FRIGATE then                    -- Frigates
                            bp.dps = 100
                        elseif cats.ANTIAIR then                    -- Aeon AA Boat
                            bp.dps = 10
                        end
                    elseif cats.AIR then
                        if cats.GROUNDATTACK then                   -- Gunships
                            bp.dps = 30
                        elseif cats.ANTIAIR then                    -- Interceptors
                            bp.dps = 15
                        elseif cats.BOMBER then                     -- Light Bombers
                            bp.dps = 90
                        elseif cats.SCOUT then                      -- Air Scouts
                            bp.dps = 0.5
                        elseif cats.TRANSPORTATION then             -- Air Transports
                            bp.dps = 30
                        end
                    elseif cats.STRUCTURE then
                        if cats.ANTIAIR then                        -- Light AA Turret
                            bp.dps = 75
                        elseif cats.DIRECTFIRE then                 -- Point Defense
                            bp.dps = 75
                        elseif cats.ANTINAVY then                   -- Light Torpedo Launcher
                            bp.dps = 300
                        else
                            bp.dps = 100                            -- Regular Buildings
                        end                         
                    end
                elseif cats.TECH2 then
                    if cats.LAND then
                        if cats.HEAVYWEAPONS then                   -- Hoplite and Mongoose
                            bp.dps = 250
                        elseif cats.DIRECTFIRE then                 -- Heavy Tanks
                            bp.dps = 100
                        elseif cats.INDIRECTFIRE then               -- Mobile Missile Launchers
                            bp.dps = 200
                        elseif cats.ANTIAIR then                    -- Mobile Flak
                            bp.dps = 200
                        else
                            bp.dps = 25                             -- Mobile Stealth Gen
                        end
                    elseif cats.NAVAL then
                        if cats.DESTROYER then                      -- Destroyers
                            bp.dps = 400
                        elseif cats.CRUISER then                    -- Cruisers
                            bp.dps = 250
                        elseif cats.LIGHTBOAT then                  -- Torpedo Boat
                            bp.dps = 150
                        elseif cats.SUBHUNTER then                  -- Missile Ship
                            bp.dps = 500
                        else
                            bp.dps = 50                             -- Shield boat and Counter Intelligence boat
                        end
                    elseif cats.AIR then
                        if cats.ANTINAVY then                       -- Torpedo Bombers
                            bp.dps = 200
                        elseif cats.BOMBER then                     -- Heavy Bombers
                            bp.dps = 250
                        elseif cats.GROUNDATTACK then               -- Gunships
                            bp.dps = 100
                        elseif cats.TRANSPORTATION then             -- Transports
                            bp.dps = 50
                        elseif cats.ANTIAIR then                    -- Aeon Combat Fighter
                            bp.dps = 150
                        end
                    elseif cats.STRUCTURE then
                        if cats.ANTIAIR then                        -- Flak Turrets
                            bp.dps = 250
                        elseif cats.DIRECTFIRE then                 -- Advanced Point Defense
                            bp.dps = 200
                        elseif cats.ANTINAVY then                   -- Heavy Torpedo Launchers
                            bp.dps = 1200
                        elseif cats.ARTILLERY then                  -- Artillery Installations
                            bp.dps = 600
                        elseif cats.TACTICALMISSILEPLATFORM then    -- Tactical Missile Launchers
                            bp.dps = 800
                        else
                            bp.dps = 300                            -- Regular Buildings
                        end
                    end
                elseif cats.TECH3 then
                    if cats.LAND then
                        if cats.DIRECTFIRE then                     -- Special Assault Bots
                            bp.dps = 200
                        elseif cats.ARTILLERY then                  -- Heavy Mobile Artillery
                            bp.dps = 300
                        elseif cats.INDIRECTFIRE then               -- Heavy Mobile Missile Launcher
                            bp.dps = 300
                        else
                            bp.dps = 25                             -- Mobile Shield Gens
                        end
                    elseif cats.NAVAL then
                        if cats.BATTLESHIP then                     -- Battleships
                            bp.dps = 1800
                        elseif cats.BATTLECRUISER then              -- Battlecruiser
                            bp.dps = 1000
                        elseif cats.CARRIER then                    -- Aircraft Carriers
                            bp.dps = 300
                        elseif cats.NUKESUB then                    -- Nuke Subs
                            bp.dps = 5000
                        elseif cats.MISSILESHIP then                -- Missile Ship
                            bp.dps = 400
                        end
                    elseif cats.AIR then
                        if cats.ANTINAVY then                       -- Advanced Torpedo Bomber
                            bp.dps = 500
                        elseif cats.BOMBER then                     -- Strategic Bombers
                            bp.dps = 1000
                        elseif cats.ANTIAIR and cats.GROUNDATTACK then  -- Aeon AA Gunship
                            bp.dps = 150
                        elseif cats.ANTIAIR then                    -- Air Superiority Fighters
                            bp.dps = 100
                        elseif cats.GROUNDATTACK then               -- UEF Broadsword
                            bp.dps = 300
                        elseif cats.TRANSPORTATION then             -- UEF Heavy Transport
                            bp.dps = 200
                        else
                            bp.dps = 25                             -- Spy Planes
                        end
                    elseif cats.STRUCTURE then
                        if cats.ANTIAIR then                        -- Advanced AA Missile Launchers
                            bp.dps = 600
                        elseif cats.NUKE then                       -- Nuke Launchers
                            bp.dps = 5000
                        elseif cats.ARTILLERY then                  -- Heavy Artillery Installations
                            bp.dps = 1000
                        elseif cats.DIRECTFIRE then                 -- UEF T3 Point Defense
                            bp.dps = 400
                        else
                            bp.dps = 5000                           -- Regular Buildings
                        end
                    else
                        bp.dps = 100                                -- Sonar Platforms
                    end
                end
            end
			--Add multiplier to slow down leveling up
			bp.dps = bp.dps * 1.5
        --end     
    end -- End of unit loop
	
--                                                                                         
--                                     PROJECTILES                                         
--                                                                                         

    -- Does this do the same thing???
    --all_bps.Projectile["CAANANODART01"].Physics.MaxSpeed = 50

    for id,bp in pairs(all_bps.Projectile) do 

        local IsTorpedo = false
        if bp.Categories then
            for k,v in bp.Categories do
                if v == 'TORPEDO' then
                    IsTorpedo = true
                    break
                end
            end
        end
        if IsTorpedo == true then
            local a,z = string.find(string.upper(bp.BlueprintId),'AANTORPEDO01')
            local b,z = string.find(string.upper(bp.BlueprintId),'TANANGLERTORPEDO02')
            local c,z = string.find(string.upper(bp.BlueprintId),'CANTORPEDONANITE01')
            local d,z = string.find(string.upper(bp.BlueprintId),'SANUALLCAVITATIONTORPEDO02')
            if not bp.Defense then
                bp.Defense = {}
            end
            if a or b or c or d then
                bp.Defense.Health = 2
                bp.Defense.MaxHealth = 2
            else
                bp.Defense.Health = 16
                bp.Defense.MaxHealth = 16
            end
        end

        -- Cybran T1 AA missile
        local a,b = string.find(string.upper(bp.BlueprintId),'CAANANODART01')
        if a then
            bp.Physics.MaxSpeed = 50
        end
        -- Seraphim Tactical Missile
        local a,b = string.find(string.upper(bp.BlueprintId),'SIFLAANSETACTICALMISSILE04')
        if a then
            bp.Economy.BuildCostEnergy = 18000
            bp.Economy.BuildCostMass = 10
            bp.Categories = {
                    'UEF',
                    'PROJECTILE',
                    'INDIRECTFIRE',
                    'MISSILE',
                    'NOSPLASHDAMAGE',
                }
        end
        -- Human Tactical Missiles
        local a,z = string.find(string.upper(bp.BlueprintId),'AIFMISSILETACTICAL01')
        local b,z = string.find(string.upper(bp.BlueprintId),'TIFMISSILECRUISE01')
        local c,z = string.find(string.upper(bp.BlueprintId),'CIFMISSILETACTICAL03')
        if c then
            bp.Defense.Health = 4
            bp.Defense.MaxHealth = 4
        elseif a or b then
            bp.Defense.Health = 6
            bp.Defense.MaxHealth = 6
        end
        -- MML Projectiles
        local a,z = string.find(string.upper(bp.BlueprintId),'TIFMISSILECRUISE03')
        local b,z = string.find(string.upper(bp.BlueprintId),'CIFMISSILETACTICAL01')
        local c,z = string.find(string.upper(bp.BlueprintId),'AIFMISSILESERPENTINE01')
        local d,z = string.find(string.upper(bp.BlueprintId),'SIFLAANSETACTICALMISSILE01')
        local e,z = string.find(string.upper(bp.BlueprintId),'TIFMISSILECRUISE05')
        if a or b or c or d or e then
            bp.Defense.Health = 2
            bp.Defense.MaxHealth = 2
        end

        -- SAM missiles
        local a,z = string.find(string.upper(bp.BlueprintId),'AAAZEALOTMISSILE01')
        local b,z = string.find(string.upper(bp.BlueprintId),'TAAMISSILEFLAYER01')
        local c,z = string.find(string.upper(bp.BlueprintId),'CAAMISSILENANITE02')
        local d,z = string.find(string.upper(bp.BlueprintId),'SAALOSAAREAUTOCANNON04')
        if a or b or c or d then
            bp.Physics.OnLostTargetLifetime = 10
        end

        -- Modify projectile scripts for "tactical" nuclear weapons.
        local a,z = string.find(string.upper(bp.BlueprintId),'AIFQUANTUMWARHEAD03')
        local b,z = string.find(string.upper(bp.BlueprintId),'CIFEMPFLUXWARHEAD04')
        local c,z = string.find(string.upper(bp.BlueprintId),'TIFMISSILENUKE02')
        local d,z = string.find(string.upper(bp.BlueprintId),'TIFMISSILENUKECDR')
        local e,z = string.find(string.upper(bp.BlueprintId),'SIFINAINOSTRATEGICMISSILE02')
        if a or b or c or d or e then
            bp.Categories = {
                'PROJECTILE',
                'INDIRECTFIRE',
                'TACTICAL',
                'MISSILE',
                'NOSPLASHDAMAGE',
            }
            if a then
                table.insert(bp.Categories,'AEON')
            elseif b then
                table.insert(bp.Categories,'CYBRAN')
            elseif e then
                table.insert(bp.Categories,'SERAPHIM')
            else
                table.insert(bp.Categories,'UEF')
            end
            bp.Defense.Health = 12
            bp.Defense.MaxHealth = 12
            bp.DesiredShooterCap = 4
            bp.Economy.BuildCostEnergy = 150000
            bp.Economy.BuildCostMass = 10000
            if d then
                bp.Economy.BuildTime = 3000
            else
                bp.Economy.BuildTime = 200000
            end
            if e then
                bp.Audio = {
                    ExistLoop = Sound {
                        Bank = 'UELWeapon',
                        Cue = 'UEF_Nuke_Flight',
                        LodCutoff = 'DefaultLodCutoff',
                    },
                    ImpactTerrain = Sound {
                        Bank = 'Impacts',
                        Cue = 'XSB2305_Impact',
                        LodCutoff = 'Weapon_LodCutoff',
                    },
                    ImpactWater = Sound {
                        Bank = 'Impacts',
                        Cue = 'XSB2305_Impact',
                        LodCutoff = 'Weapon_LodCutoff',
                    },
                    NukeExplosion = Sound {
                        Bank = 'Impacts',
                        Cue = 'XSB2305_Impact',
                        LodCutoff = 'Weapon_LodCutoff',
                    }
                }
            end
            bp.General.EntityCategory = {
                'PROJECTILE',
                'INDIRECTFIRE',
                'TACTICAL',
                'MISSILE',
                'NOSPLASHDAMAGE',
            }
            if a then
                table.insert(bp.General.EntityCategory,'AEON')
            elseif b then
                table.insert(bp.General.EntityCategory,'CYBRAN')
            elseif e then
                table.insert(bp.General.EntityCategory,'SERAPHIM')
            else
                table.insert(bp.General.EntityCategory,'UEF')
            end
            bp.Physics.Acceleration = 0.25
            bp.Physics.InitialSpeed = 1
            bp.Physics.MaxSpeed = 10
            bp.Physics.TurnRate = 15
        end
    end

--                                                                                         
--                                        PROPS                                            
--                                                                                         

    for id,bp in pairs(all_bps.Prop) do
        if bp.ScriptClass == 'Tree' then
            bp.Display.UniformScale = bp.Display.UniformScale * 1.5
        end
        if bp.Categories then
            local cats = {}
            for k,cat in pairs(bp.Categories) do
                cats[cat] = true
            end
            if cats.RECLAIMABLE then
                if bp.Economy.ReclaimMassMax then
                    if type(bp.Economy.ReclaimMassMax) == 'number' then
                        -- Make reclaimable map objects worth 2x as much
                        bp.Economy.ReclaimMassMax = bp.Economy.ReclaimMassMax * 2
                    end
                end
            end
        end
    end     -- End of prop loop
    
--    
--                          Effects
--                
    for id,bp in pairs(all_bps.Emitter) do
        if string.find(bp.BlueprintId, "flash") or string.find(bp.BlueprintId, "muzzle") then
            #LOG("|| Modifying Emitter: " .. bp.BlueprintId)
            if bp.Lifetime and bp.Lifetime < 2 and bp.Lifetime > 0 then
                bp.Lifetime = bp.Lifetime *2
            end
            if bp.StartSizeCurve and bp.StartSizeCurve.Keys then
                for k,v in pairs(bp.StartSizeCurve.Keys) do
                    v.x = v.x*2
                    v.y = v.y*2
                    v.z = v.z*2
                end
            end
            if bp.EndSizeCurve and bp.EndSizeCurve.Keys then
                for k,v in pairs(bp.EndSizeCurve.Keys) do
                    v.x = v.x*2
                    v.y = v.y*2
                    v.z = v.z*2
                end
            end    
        end
    end   
end

--                                                                                         
--                              TARGETING PRIORITIY TEMPLATES                              
--                                                                                         


T1_Point_Defense = {
    'SPECIALHIGHPRI',
    'TECH1 ARTILLERY',                  -- Light Artillery:  Very high threat to PD
    'TECH1 DIRECTFIRE',                 -- Light Tanks: Main purpose of PD is to kill these
    'COMMAND',                          -- Kill the ACU if you can
    'MOBILE',                           -- Mobile Units are more important than Structures
    'STRUCTURE DEFENSE',                -- If built in range of enemy defense, take them out before benign structures.
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Light_AA_Gun = {                        -- T1 AA Turret, T1 Mobile AA, Interceptors, Frigate AA
    'SPECIALHIGHPRI',
    'AIR MOBILE HIGHPRIAIR',
    'AIR MOBILE TRANSPORTATION',        -- All Transports very important
    'AIR MOBILE TECH1 GROUNDATTACK',    -- Cybran Light Gunships
    'AIR MOBILE TECH1 BOMBER',          -- All T1 Bombers
    'AIR MOBILE BOMBER',                -- T2 and T3 Bombers
    'AIR MOBILE GROUNDATTACK',          -- T2 and T3 Gunships
    'AIR MOBILE TECH1',                 -- Interceptors and Scouts
    'AIR MOBILE TECH2',                 -- Whatever is left over in T2
    'AIR MOBILE',                       -- Everything Else
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Transport_AA_Gun = {                    -- Self-Defense for Air Transports
    'SPECIALHIGHPRI',
    'AIR MOBILE HIGHPRIAIR',
    'AIR MOBILE ANTIAIR',               -- Shoot at interceptors first
    'AIR MOBILE TRANSPORTATION',        -- All Transports very important
    'AIR MOBILE TECH1 GROUNDATTACK',    -- Cybran Light Gunships
    'AIR MOBILE TECH1 BOMBER',          -- All T1 Bombers
    'AIR MOBILE BOMBER',                -- T2 and T3 Bombers
    'AIR MOBILE GROUNDATTACK',          -- T2 and T3 Gunships
    'AIR MOBILE TECH1',                 -- Interceptors and Scouts
    'AIR MOBILE TECH2',                 -- Whatever is left over in T2
    'AIR MOBILE',                       -- Everything Else
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Medium_AA_Gun = {                       -- T2 Fighter/Bombers
    'SPECIALHIGHPRI',
    'AIR MOBILE HIGHPRIAIR',
    'AIR MOBILE TRANSPORTATION',        -- All Transports very important
    'AIR MOBILE TECH1 GROUNDATTACK',    -- Cybran Light Gunships
    'AIR MOBILE TECH1 BOMBER',          -- All T1 Bombers
    'AIR MOBILE TECH1 ANTIAIR',         -- Take out interceptors ASAP
    'AIR MOBILE BOMBER',                -- T2 and T3 Bombers
    'AIR MOBILE GROUNDATTACK',          -- T2 and T3 Gunships
    'AIR MOBILE',                       -- Everything Else
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Heavy_AA_Missile = {
    'SPECIALHIGHPRI',
    'TECH3 AIR INTELLIGENCE',
    'AIR EXPERIMENTAL',
    'TECH3 BOMBER',
    'TECH3 GROUNDATTACK',
    'AIR ANTINAVY',
    'TECH3 TRANSPORTATION',
    'TECH2 TRANSPORTATION',
    'TRANSPORTATION',
    'TECH2 GROUNDATTACK',
    'TECH2 BOMBER',
    'TECH3 AIR ANTIAIR',
    'TECH2 AIR ANTIAIR',
    'TECH1 AIR ANTIAIR',
    'AIR',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Flak = {
    'SPECIALHIGHPRI',
    'AIR MOBILE GROUNDATTACK',          -- Gunships
    'BOMBER',                           -- Bombers
    'AIR MOBILE TRANSPORTATION',        -- Transports are faster than bombers and fairly tough too - not the best Flak targets.
    'AIR MOBILE',                       -- Any other planes are going to be too fast for Flak to hit reliably.
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Cruiser_AA = {
    'SPECIALHIGHPRI',
    'AIR ANTINAVY',                     -- Torpedo Bombers are #1 Priority
    'AIR TECH3 BOMBER',                 -- Strategic Bombers are #2 Priority
    'AIR MOBILE GROUNDATTACK',          -- T2 and T3 Gunships
    'AIR MOBILE TRANSPORTATION',        -- All Transports very important
    'AIR BOMBER',                       -- All Other Bombers
    'AIR TECH1 ANTIAIR',                -- Take out interceptors
    'AIR MOBILE',                       -- Everything Else
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Carrier_AA = {
    'SPECIALHIGHPRI',
    'AIR ANTINAVY',                     -- Torpedo Bombers are #1 Priority
    'TECH3 BOMBER',                     -- Strategic Bombers are #2 Priority
    'TECH3 AIR ANTIAIR',                -- ASF's
    'TECH2 AIR ANTIAIR',                -- Fighter/Bombers
    'TECH1 AIR ANTIAIR',                -- Interceptors
    'GROUNDATTACK',                     -- T2 and T3 Gunships
    'TRANSPORTATION',                   -- All Transports very important
    'BOMBER',                           -- All Other Bombers
    'AIR MOBILE',                       -- Everything Else
    'SPECIALLOWPRI',
    'ALLUNITS',
}

T1_Torpedo = {                          -- Torp Launchers, Subs, Any amphibious units with torps
    'SPECIALHIGHPRI',
    'FRIGATE',                          -- Frigates are the biggest threat to the Torp Launcher that it can kill quickly.
    'T1SUBMARINE',                      -- Submarines are also a major threat the TL can kill quickly.
    'TECH1 NAVAL MOBILE',               -- For the Aeon AA boat. Easy kill.
    'NUKESUB',                          -- Major threat to base, Kill if possible.
    'CRUISER',                          -- Important naval escort - likely not equipped with Torp Defenses.
    'SUBHUNTER',                        -- Kill this major threat to your subs easily if you discover one lurking about.
    'MISSILESHIP',                      -- Major threat to base, Kill if possible.
    'DESTROYER',                        -- Major threat. Kill if possible, but it will take a while.
    'TECH2 NAVAL MOBILE',               -- Any other T2 stuff.
    'TECH3 NAVAL MOBILE',               -- Battleships and other heavy naval units
    'COMMAND',                          -- Not likely to damage the ACU - ships are more important targets.
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Heavy_Torpedo = {                       -- T2 and T3 Torp Launchers
    'SPECIALHIGHPRI',
    'COMMAND',                          -- Heavy torpedoes can kill the ACU - Take him out if you can!!
    'EXPERIMENTAL NAVAL',               -- Atlantis and Tempest
    'NUKESUB',                          -- Major threat to base, Kill if discovered
    'DESTROYER',                        -- Major naval threat. Take these out!
    'CRUISER',                          -- Important naval escort - likely not equipped with Torp Defenses.
    'SUBHUNTER',                        -- Kill this major threat to your subs easily if you discover one lurking about.
    'MISSILESHIP',                      -- Major threat to base, Kill if discovered.
    'BATTLESHIP',                       -- If found, cause as much damage to Battleships as you can.  Heavy torps are a good threat to them.
    'BATTLECRUISER',                    -- If found, cause as much damage to Battlecruisers as you can.  Heavy torps are a good threat to them.
    'FRIGATE',                          -- Frigates should be dealth with but usually other units can handle them.
    'T1SUBMARINE',                      -- Submarines aren't heavy enough to be a priority for this unit
    'TECH2 NAVAL MOBILE',               -- Any other T2 stuff.
    'TECH3 NAVAL MOBILE',               -- Other heavy naval units.
    'NAVAL MOBILE',                     -- Anything else on the water.
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Scout = {
    'LAND INTELLIGENCE',                -- Other scouts is the only likely target we will be able to kill.
    'TECH1 MASSEXTRACTION',             -- T1 Mexxes are fragile and key to early expansion. Kill these if found.
    'TECH1 ENGINEER',                   -- Harrass and maybe kill T1 engineers. They aren't too tough and don't automatically shoot back.
    'ALLUNITS',
}

Light_Attack_Bot = {                    -- LABs, T1 Gunship, T2 Transports
    'SPECIALHIGHPRI',
    'LAND INTELLIGENCE',                -- Scouts provide critical Intel for the enemy. Take these easy kills above all else.
    'TECH1 MASSEXTRACTION',             -- Very easy kill which disrupts enemy economy the most when LABs are running around early.
    'TECH1 MASSFABRICATION',            -- A pack of LABs can kill a T1 Fab fast enough to make it chain react.
    'ENGINEER',                         -- T1 Engineers are critical units to the enemy's expansion. Kill these above all combat units.
    'TECH1 ARTILLERY',                  -- T1 Artillery is fragile and devastating to your defenses.  Kill these above regular tanks.
    'STRUCTURE INTELLIGENCE',           -- Easy kill which cripples enemy Intel without a lot of effort.
    'TECH1 LAND DIRECTFIRE',            -- Typical T1 attack units are higher priority over higher tech mobiles or structures.
    'COMMAND',                          -- Attack the ACU if easy kill targets aren't around.
    'TECH1 STRUCTURE ANTIAIR',          -- AA turrets are no threat to LABs and have low armor.
    'TECH1 ECONOMIC',                   -- Power generating structures
    'TECH2 LAND DIRECTFIRE',            -- Harder to kill units like T2 tanks
    'STRUCTURE DEFENSE',                -- Defenses are very hard for LABs to kill.  But if they are in range, contribute firepower anyway.
    'MOBILE',                           -- Kill generic mobile units before generic structures.
    'ALLUNITS',
}

Medium_Assault_Unit = {                 -- T1 main attack units
    'SPECIALHIGHPRI',
    'LAND INTELLIGENCE',
    'TECH1 MASSEXTRACTION',
    'TECH1 MASSFABRICATION',
    'ENGINEER',
    'TECH1 ARTILLERY',
    'STRUCTURE INTELLIGENCE',           -- Easy kill which cripples enemy Intel without a lot of effort.
    'TECH1 LAND DIRECTFIRE',
    'COMMAND',
    'TECH2 LAND DIRECTFIRE',
    'STRUCTURE DEFENSE',
    'TECH1 ECONOMIC',                   -- The difference from LAB priorities here is T1 economic is a lower priority than Defenses and T2 Tanks
    'MOBILE',
    'ALLUNITS',
}

ACU_Cannon = {
    'SPECIALHIGHPRI',
    'LAND INTELLIGENCE',
    'TECH1 MASSEXTRACTION',
    'TECH1 MASSFABRICATION',
    'ENGINEER',
    'TECH1 ARTILLERY',
    'STRUCTURE INTELLIGENCE',
    'TECH1 LAND DIRECTFIRE',
    'COMMAND',
    'TECH2 LAND DIRECTFIRE',
    'STRUCTURE DEFENSE',
    'TECH1 ECONOMIC',
    'LAND',
    'NAVAL',
    'STRUCTURE',
    'AIR',
    'ALLUNITS',
}
Heavy_Assault_Unit = {
    'SPECIALHIGHPRI',
    'ORBITALSYSTEM',
    'LAND INTELLIGENCE',
    'TECH1 MASSEXTRACTION',
    'TECH1 MASSFABRICATION',
    'TECH1 ENGINEER',
    'TECH2 ENGINEER',
    'TECH3 ENGINEER',
    'STRUCTURE INTELLIGENCE',
    'COMMAND',
    'TECH1 ARTILLERY',
    'TECH2 LAND DIRECTFIRE',
    'TECH1 LAND DIRECTFIRE',
    'STRUCTURE DEFENSE',
    'TECH2 ECONOMIC',
    'TECH1 ECONOMIC',
    'MOBILE',
    'ALLUNITS',
}

Extreme_Assault_FastReload = {
    'SPECIALHIGHPRI',
    'ORBITALSYSTEM',
    'LAND INTELLIGENCE',
    'TECH1 MASSEXTRACTION',
    'TECH1 MASSFABRICATION',
    'TECH3 ENGINEER',
    'TECH2 ENGINEER',
    'TECH1 ENGINEER',
    'STRUCTURE INTELLIGENCE',
    'COMMAND',
    'EXPERIMENTAL',
    'TECH3 LAND DIRECTFIRE',
    'TECH2 LAND DIRECTFIRE',
    'STRUCTURE DEFENSE',
    'INDIRECTFIRE',
    'TECH1 LAND DIRECTFIRE',
    'TECH3 ECONOMIC',
    'TECH2 ECONOMIC',
    'TECH1 ECONOMIC',
    'MOBILE',
    'ALLUNITS',
}

Extreme_Assault_SlowReload = {
    'SPECIALHIGHPRI',
    'COMMAND',
    'ORBITALSYSTEM',
    'TECH3 INTELLIGENCE STRUCTURE',
    'TECH2 INTELLIGENCE STRUCTURE',
    'EXPERIMENTAL',
    'TECH3 INDIRECTFIRE',
    'TECH3 DIRECTFIRE',
    'TECH3 MASSFABRICATION',
    'GATE',
    'TECH3 ENERGYPRODUCTION',
    'TECH3 FACTORY',
    'TECH2 DEFENSE STRUCTURE',
    'TECH2 ENERGYPRODUCTION',
    'TECH2 FACTORY',
    'TECH1 FACTORY',
    'TECH3',
    'TECH2',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Light_Slow_AntiStructure = {            -- T1 Mobile Artillery, Bombers
    'SPECIALHIGHPRI',
    'STRUCTURE INTELLIGENCE',           -- Super easy kill which cripples enemy Intel usually with one hit.
    'TECH1 STRUCTURE DIRECTFIRE',       -- Top Priority for T1 Artllery is to kill T1 Point Defenses.
    'TECH1 STRUCTURE ANTIAIR',          -- AA Turrets are targets of opportunity.
    'TECH1 MASSEXTRACTION',             -- Very easy kill which disrupts enemy economy without spending a lot of time on one target.
    'TECH1 MASSFABRICATION',            -- Easy to cause a chain reaction.
    'STRUCTURE DIRECTFIRE',             -- T2 and other defense structures are also high priority.
    'TECH1 ECONOMIC',                   -- Killing less hardened T1 economic structures is more fruitful than pursuing moving targets.
    'TECH2 LAND INDIRECTFIRE',          -- Mobile Missile Launchers are easy kills if you can get them in range.
    'STRUCTURE ANTIAIR',                -- Flak and SAM Launchers
    'COMMAND',                          -- Attack the ACU if easy kill targets aren't present.
    'ORBITALSYSTEM',
    'TECH3 MOBILE ARTILLERY',           -- If you can get within range of these, take them out.
    'FACTORY',                          -- Enemy production is higher priority than mobiles
    'STRUCTURE',
    'MOBILE',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Heavy_Slow_AntiStructure = {            -- Mobile Missile Launchers, T3 Mobile Artillery
    'SPECIALHIGHPRI',
    'ORBITALSYSTEM',
    'STRUCTURE INTELLIGENCE',         
    'TECH2 STRUCTURE DIRECTFIRE',     
    'TECH2 STRUCTURE ANTIAIR',        
    'COMMAND',                        
    'MASSEXTRACTION',                 
    'MASSFABRICATION',          
    'STRUCTURE DIRECTFIRE',           
    'ECONOMIC',                 
    'TECH2 LAND INDIRECTFIRE',        
    'STRUCTURE ANTIAIR',              
    'TECH3 MOBILE ARTILLERY',         
    'FACTORY',                        
    'STRUCTURE',
    'MOBILE',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

ExtraHeavy_Slow_AntiStructure = {       -- Strategic Bombers
    'SPECIALHIGHPRI',
    'COMMAND',
    'ORBITALSYSTEM',
    'TECH3 STRUCTURE ANTIAIR',
    'TECH3 STRUCTURE SILO',
    'TECH3 STRUCTURE INTELLIGENCE',
    'EXPERIMENTAL',
    'STRUCTURE INTELLIGENCE',
    'TECH3 STRUCTURE DIRECTFIRE',
    'TECH2 STRUCTURE DIRECTFIRE',
    'TECH2 STRUCTURE ANTIAIR',
    'MASSEXTRACTION',
    'MASSFABRICATION',          
    'STRUCTURE DIRECTFIRE',           
    'ECONOMIC',                 
    'TECH2 LAND INDIRECTFIRE',        
    'STRUCTURE ANTIAIR',              
    'TECH3 MOBILE ARTILLERY',         
    'FACTORY',                        
    'STRUCTURE',
    'MOBILE',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Long_Range_Artillery = {
    'SPECIALHIGHPRI',
    'COMMAND',
    'ORBITALSYSTEM',
    'EXPERIMENTAL STRUCTURE',
    'TECH1 MASSFABRICATION',
    'TECH3 MASSFABRICATION',
    'TECH3 INTELLIGENCE STRUCTURE',
    'TECH2 INTELLIGENCE STRUCTURE',
    'TECH1 INTELLIGENCE STRUCTURE',
    'GATE',
    'TECH2 DEFENSE STRUCTURE',
    'TECH1 DEFENSE STRUCTURE',
    'TECH3 ENERGYPRODUCTION',
    'TECH2 ENERGYPRODUCTION',
    'TECH1 ENERGYPRODUCTION',
    'TECH3 FACTORY',
    'TECH2 FACTORY',
    'TECH1 FACTORY',
    'STRUCTURE',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Beam_Of_Death = {
    'SPECIALHIGHPRI',
    'COMMAND',
    'EXPERIMENTAL',
    'TECH3 MASSFABRICATION',
    'TECH3 MASSEXTRACTION',
    'TECH3 INTELLIGENCE STRUCTURE',
    'TECH3 STRUCTURE SILO',
    'GATE',
    'TECH3 STRUCTURE ARTILLERY',
    'SUBCOMMANDER',
    'TECH3 ENERGYPRODUCTION',
    'TECH3 DIRECTFIRE',
    'TECH3 INDIRECTFIRE',
    'TECH2 ARTILLERY',
    'TECH3 FACTORY',
    'TECH3 STRUCTURE',
    'TECH3 MOBILE',
    'MOBILE',
    'STRUCTURE',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Tractor_Claw = {
    'SPECIALHIGHPRI',
    'SUBCOMMANDER',
    'TECH3 BOMBER',
    'TECH3 GROUNDATTACK',
    'TECH3 LAND DIRECTFIRE',
    'TECH3 LAND INDIRECTFIRE',
    'TECH3 AIR INTELLIGENCE',
    'TECH2 LAND DIRECTFIRE',
    'TECH2 LAND INDIRECTFIRE',
    'TECH3 AIR',
    'TECH2 AIR',
    'TECH2',
    'TECH1',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Light_Naval_Cannon = {
    'SPECIALHIGHPRI',
    'STRUCTURE INTELLIGENCE',           -- Easy kill which cripples enemy Intel without a lot of effort.
    'FRIGATE',                          -- Other Frigates are probably a frigate's highest priority to kill.
    'TECH1 ENGINEER',
    'TECH2 ENGINEER',                   -- Amphibious engineers should be taken out quickly.
    'TECH3 ENGINEER',
    'HOVER',                            -- Keep land units in their place  On land or dead.
    'TECH1 NAVAL MOBILE',               -- For the Aeon AA boat. Easy kill.
    'CRUISER',                          -- Important naval escort.  Mass for mass frigates will win this battle.
    'MISSILESHIP',                      -- Major threat to base, Kill if possible.
    'COMMAND',                          -- If you spot the ACU on land and in range, try and hit it.
    'DESTROYER',                        -- Major threat. Unlikely to kill them but you might in numbers.
    'TECH2 NAVAL MOBILE',               -- Any other T2 stuff.
    'TECH3 NAVAL MOBILE',               -- Battleships and other heavy naval units
    'MOBILE',
    'STRUCTURE',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Heavy_Naval_Artillery = {
    'SPECIALHIGHPRI',
    'STRUCTURE INTELLIGENCE', 
    'COMMAND',                
    'EXPERIMENTAL STRUCTURE',
    'BATTLESHIP',                
    'BATTLESCRUISER',                
    'MISSILESHIP',            
    'DESTROYER',              
    'TECH1 MASSFABRICATION',
    'TECH3 MASSFABRICATION',
    'TECH3 INTELLIGENCE STRUCTURE',
    'TECH2 INTELLIGENCE STRUCTURE',
    'GATE',
    'TECH2 DEFENSE STRUCTURE',
    'TECH3 ENERGYPRODUCTION',
    'TECH2 ENERGYPRODUCTION',
    'TECH3 FACTORY',
    'TECH2 FACTORY',
    'NAVAL MOBILE',
    'STRUCTURE',
    'MOBILE',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Heavy_Naval_Cannon = {
    'SPECIALHIGHPRI',
    'STRUCTURE INTELLIGENCE', 
    'COMMAND',                
    'DESTROYER',              
    'MISSILESHIP',            
    'BATTLESCRUISER',                
    'BATTLESHIP',                
    'CRUISER',                
    'FRIGATE',                
    'ENGINEER',
    'HOVER',                  
    'TECH2 NAVAL MOBILE',     
    'TECH1 NAVAL MOBILE',     
    'TECH3 NAVAL MOBILE',     
    'MOBILE',
    'STRUCTURE',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Light_NonNaval_Ship_Cannon = {          -- Sub guns and cruiser turrets
    'SPECIALHIGHPRI',
    'STRUCTURE INTELLIGENCE',           -- Easy kill which cripples enemy Intel without a lot of effort.
    'TECH1 ENGINEER',
    'TECH2 ENGINEER',                   -- Amphibious engineers should be taken out quickly.
    'TECH3 ENGINEER',
    'HOVER',                            -- Keep land units in their place  On land or dead.
    'COMMAND',                          -- If you spot the ACU on land and in range, try and hit it.
    'LAND',                             -- Tanks and land units sitting on the shore line.
    'STRUCTURE ECONOMIC',               -- If near a shoreline, take out buildings nearby.
    'FRIGATE',                          -- Any ship will be harder to kill for NonNaval cannons
    'TECH1 NAVAL MOILE',                -- For the Aeon AA boat. Easy kill.
    'CRUISER',                          -- Important naval escort.  Mass for mass frigates will win this battle.
    'MISSILESHIP',                      -- Major threat to base, Kill if possible.
    'DESTROYER',                        -- Major threat. Unlikely to kill them but you might in numbers.
    'TECH2 NAVAL MOBILE',               -- Any other T2 stuff.
    'TECH3 NAVAL MOBILE',               -- Battleships and other heavy naval units
    'MOBILE',
    'STRUCTURE',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Slow_T2PD = {                           -- Aeon and UEF T2 Point Defense
    'SPECIALHIGHPRI',
    'STRUCTURE INTELLIGENCE',           -- Super easy kill which cripples enemy Intel usually with one hit.
    'COMMAND',                          -- T2PD can kill the ACU - Take him out if you can!!
    'LAND EXPERIMENTAL',                -- Contribute to taking down Experimentals whenever possible.
    'TECH2 LAND INDIRECTFIRE',          -- Biggest threat to T2PD.  Probably wont get many of these but if they show up, pop them.
    'TECH3 LAND INDIRECTFIRE',          -- Also very large threat to T2PD.  Probably wont get many of these but if they show up, pop them.
    'TECH3 LAND DIRECTFIRE',            -- Extreme and Custom Assault units need to be focused on.
    'TECH2 LAND DIRECTFIRE',            -- Heavy assault units need to be focused on.
    'TECH1 ARTILLERY',                  -- T1 Mobile Artillery
    'TECH1 LAND DIRECTFIRE',            -- T1 Tanks and LABs
    'MOBILE',
    'STRUCTURE DEFENSE',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Fast_T2PD = {                           -- Cybran and Seraphim T2 Point Defense
    'SPECIALHIGHPRI',
    'STRUCTURE INTELLIGENCE',           -- Super easy kill which cripples enemy Intel usually with one hit.
    'LAND INTELLIGENCE',                -- Scouts provide critical Intel for the enemy. Take these easy kills above all else.
    'TECH1 MASSEXTRACTION',             -- Very easy kill which disrupts enemy economy the most when LABs are running around early.
    'TECH1 MASSFABRICATION',            -- A pack of LABs can kill a T1 Fab fast enough to make it chain react.
    'TECH1 ENGINEER',
    'TECH2 ENGINEER',                   -- T1 Engineers are critical units to the enemy's expansion. Kill these above all combat units.
    'TECH3 ENGINEER',
    'STRUCTURE INTELLIGENCE',           -- Easy kill which cripples enemy Intel without a lot of effort.
    'COMMAND',                          -- T2PD can kill the ACU - Take him out if you can!!
    'LAND EXPERIMENTAL',                -- Contribute to taking down Experimentals whenever possible.
    'TECH2 LAND INDIRECTFIRE',          -- Biggest threat to T2PD.  Probably wont get many of these but if they show up, pop them.
    'TECH3 LAND INDIRECTFIRE',          -- Also very large threat to T2PD.  Probably wont get many of these but if they show up, pop them.
    'TECH3 LAND DIRECTFIRE',            -- Extreme and Custom Assault units need to be focused on.
    'TECH2 LAND DIRECTFIRE',            -- Heavy assault units need to be focused on.
    'TECH1 ARTILLERY',                  -- T1 Mobile Artillery
    'TECH1 LAND DIRECTFIRE',            -- T1 Tanks and LABs
    'MOBILE',
    'STRUCTURE',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

Strategic_Bomber = {
    'SPECIALHIGHPRI',
    'TECH3 ANTIAIR',
    'COMMAND',
    'ORBITALSYSTEM',
    'TECH3 MASSFABRICATION',
    'TECH3 INTELLIGENCE STRUCTURE',
    'TECH3 ENERGYPRODUCTION',
    'TECH3 FACTORY',
    'TECH2 INTELLIGENCE STRUCTURE',
    'LAND EXPERIMENTAL',
    'TECH2 ENERGYPRODUCTION',
    'TECH2 FACTORY',
    'TECH1 INTELLIGENCE STRUCTURE',
    'TECH1 MASSFABRICATION',
    'TECH1 ENERGYPRODUCTION',
    'TECH1 FACTORY',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

AntiSub = {
    'SPECIALHIGHPRI',
    'T1SUBMARINE',
    'SUBHUNTER',
    'SUBMERSIBLE',
    'NAVAL MOBILE',
    'SPECIALLOWPRI',
    'ALLUNITS',
}

AntiShield = {            -- Absolver
    'SHIELD',
    'ALLUNITS',
}

end
