#
# Seraphim BS
#
local EffectTemplate = import('/lua/EffectTemplates.lua')
local OldProjectile = SDFHeavyQuarnonCannon01
local RandomFloat = import('/lua/utilities.lua').GetRandomFloat
SDFHeavyQuarnonCannon01 = Class(OldProjectile) {

    FxImpactLand = EffectTemplate.SRifterArtilleryHit,
    FxImpactWater = EffectTemplate.SRifterArtilleryWaterHit,
    FxImpactNone = EffectTemplate.SRifterArtilleryHit,
    FxImpactProjectile = {},
    FxImpactProp = EffectTemplate.SRifterArtilleryHit,    
    FxImpactUnderWater = EffectTemplate.SRifterArtilleryWaterHit,
    FxImpactUnit = EffectTemplate.SRifterArtilleryHit,    
    FxLandHitScale = 0.5,

    OnImpact = function(self, targetType, targetEntity)
        OldProjectile.OnImpact(self, targetType, targetEntity)
        local army = self:GetArmy()
        if targetType == 'Terrain' or targetType == 'Prop' then
            --CreateSplat( self:GetPosition(), 0, 'scorch_011_albedo', 4, 4, 350, 200, army )
            local rotation = RandomFloat(0,2*math.pi)
            CreateDecal(self:GetPosition(), rotation, 'crater_radial01_normals', '', 'Alpha Normals', 3, 3, 300, 0, self:GetArmy())
            CreateDecal(self:GetPosition(), rotation, 'crater_radial01_albedo', '', 'Albedo', 4, 4, 300, 0, self:GetArmy())
        end
        ForkThread(self.ForceThread, self, self:GetPosition())
        self:ShakeCamera( 2, 3, 2, 1 )        
    end,

    ForceThread = function(self, pos)
        DamageArea(self, pos, 4, 1, 'Force', true)
        WaitTicks(2)
        DamageArea(self, pos, 4, 1, 'Force', true)
        DamageRing(self, pos, 4, 15, 1, 'Fire', true)
    end,

}
TypeClass = SDFHeavyQuarnonCannon01
