do
local SSuthanusArtilleryShell = import('/lua/seraphimprojectiles.lua').SSuthanusArtilleryShell
local RandomFloat = import('/lua/utilities.lua').GetRandomFloat

SIFSuthanusArtilleryShell02 = Class(SSuthanusArtilleryShell) {

    FxLandHitScale = 3,
    FxNoneHitScale = 3,
    FxPropHitScale = 3,

    OnImpact = function(self, TargetType, TargetEntity)
        SSuthanusArtilleryShell.OnImpact(self, TargetType, TargetEntity)
        if TargetType != 'Shield' and TargetType != 'Water' and TargetType != 'UnitAir' then
            local rotation = RandomFloat(0,2*math.pi)
            CreateDecal(self:GetPosition(), rotation, 'crater_radial01_normals', '', 'Alpha Normals', 28, 28, 300, 0, self:GetArmy())
            CreateDecal(self:GetPosition(), rotation, 'crater_radial01_albedo', '', 'Albedo', 32, 32, 300, 0, self:GetArmy())
            ForkThread(self.ForceThread, self, self:GetPosition())
            self:ShakeCamera( 20, 1, 0, 1 )        
        end
    end,
    ForceThread = function(self, pos)
        DamageArea(self, pos, 12, 1, 'Force', true)
        WaitTicks(2)
        DamageArea(self, pos, 12, 1, 'Force', true)
        DamageRing(self, pos, 12, 15, 1, 'Fire', true)
    end,
}

TypeClass = SIFSuthanusArtilleryShell02
end