do

local OldUnit = URL0402
URL0402 = Class(OldUnit) {
    Weapons = {
        MainGun = Class(CDFHeavyMicrowaveLaserGenerator) {
            OnWeaponFired = function(self)
                self.unit:InitiateDisableStealth()
            end,
        },
        RightLaserTurret = Class(CDFElectronBolterWeapon) {
            OnWeaponFired = function(self)
                self.unit:InitiateDisableStealth()
            end,
        },
        LeftLaserTurret = Class(CDFElectronBolterWeapon) {
            OnWeaponFired = function(self)
                self.unit:InitiateDisableStealth()
            end,
        },
        RightAntiAirMissile = Class(CAAMissileNaniteWeapon) {
            OnWeaponFired = function(self)
                self.unit:InitiateDisableStealth()
            end,
        },
        LeftAntiAirMissile = Class(CAAMissileNaniteWeapon) {
            OnWeaponFired = function(self)
                self.unit:InitiateDisableStealth()
            end,
        },
        Torpedo = Class(CANTorpedoLauncherWeapon) {
            OnWeaponFired = function(self)
                self.unit:InitiateDisableStealth()
            end,
        },
    },
    InitiateDisableStealth = function(self)
        if self.DisableStealthThread then
            self.DisableStealthThread:Destroy()
            self.DisableStealthThread = nil
        end
        self.DisableStealthThread = self:ForkThread(self.DisableStealth, self)
    end,
    DisableStealth = function(self)
        if self:GetScriptBit('RULEUTC_StealthToggle') == false then 
            self:SetScriptBit('RULEUTC_StealthToggle', true)
        end
        WaitSeconds(3)
        if self:GetScriptBit('RULEUTC_StealthToggle') == true then 
            self:SetScriptBit('RULEUTC_StealthToggle', false)
        end
    end, 
}   
    
TypeClass = URL0402

end
