local TConstructionPlane = import('/lua/terranunits.lua').TConstructionPlane

UEA0109 = Class(TConstructionPlane) {
    EngineRotateBones = {'Jet_Front', 'Jet_Back',},

    OnStopBeingBuilt = function(self,builder,layer)
        TConstructionPlane.OnStopBeingBuilt(self,builder,layer)
        self.EngineManipulators = {}

        # create the engine thrust manipulators
        for key, value in self.EngineRotateBones do
            table.insert(self.EngineManipulators, CreateThrustController(self, "thruster", value))
        end

        # set up the thursting arcs for the engines
        for key,value in self.EngineManipulators do
            #                          XMAX, XMIN, YMAX,YMIN, ZMAX,ZMIN, TURNMULT, TURNSPEED
            value:SetThrustingParam( -0.0, 0.0, -0.25, 0.25, -0.1, 0.1, 1.0,      0.25 )
        end
        
        for k, v in self.EngineManipulators do
            self.Trash:Add(v)
        end

    end,
}

TypeClass = UEA0109