do
local OldNuke = SeraphimNukeEffectController01
SeraphimNukeEffectController01 = Class(OldNuke) {
    CreateNuclearExplosion = function(self)
        local myBlueprint = self:GetBlueprint()
        if myBlueprint.Audio.NukeExplosion then
            self:PlaySound(myBlueprint.Audio.NukeExplosion)
        end
        self:ForkThread(self.DoNukeDamage2)
        self:ForkThread(self.ForceThread2)
        self:ForkThread(self.EffectThread)
        self:ForkThread(self.CreateEffectInnerPlasma)
        self:ForkThread(self.CreateEffectElectricity)
    end,    

    DoNukeDamage2 = function(self)
        --LOG("|| DoNukeDamage2")
        local damage = self.NukeInnerRingDamage / self.NukeInnerRingTicks
        local FullDamageRadius = 15
        --LOG("|| FullDamageRadius = " .. FullDamageRadius)
        local LinearDamageRadius = 25
        --LOG("|| LinearDamageRadius = " .. LinearDamageRadius)
        local LinearDropoff = 150
        --LOG("|| LinearDropoff = " .. LinearDropoff)

        
        local pulseTime = self.NukeInnerRingTotalTime / self.NukeInnerRingTicks
        local position = self:GetPosition()
        local instigator = self:GetLauncher()
        local CurrentRadius = 0
        for i = 1, self.NukeInnerRingTicks do
            local damage = self.NukeInnerRingDamage / self.NukeInnerRingTicks
            local FullDamageRadius = 15
            local LinearDamageRadius = 25
            local LinearDropoff = 150
            --if i == 1 then
            --    LOG("|| Applying " .. damage .. " to " .. FullDamageRadius)
            --end
            --LOG("|| Count = " .. i)
            DamageArea(instigator, position, FullDamageRadius, damage, 'Nuke', true, false)
            CurrentRadius = FullDamageRadius + 1
            while CurrentRadius <= self.NukeInnerRingRadius do
                local RingDamage = 0
                if CurrentRadius <= LinearDamageRadius then
                    damage = damage - LinearDropoff
                    RingDamage = damage
                    FullDamageRadius = CurrentRadius
                else
                    local DistanceIncreaseRatio = CurrentRadius / FullDamageRadius
                    local QuadIncrease = DistanceIncreaseRatio * DistanceIncreaseRatio * DistanceIncreaseRatio * DistanceIncreaseRatio
                    RingDamage = math.floor(damage / QuadIncrease)
                end
                if RingDamage > 0 then
                    --if i == 1 then
                    --    LOG("|| Applying " .. RingDamage .. " from " .. CurrentRadius - 1 .. " to " .. CurrentRadius)
                    --end
                    DamageRing(instigator, position, CurrentRadius - 1, CurrentRadius, RingDamage, 'Nuke', true)
                end
                CurrentRadius = CurrentRadius + 1
            end
            WaitSeconds(pulseTime)
        end
    end,

    ForceThread2= function(self)
        if self.NukeInnerRingRadius >= 50 then
            local position = self:GetPosition()
            DamageRing(self, position, 45, self.NukeInnerRingRadius, 1, 'Force', true)
            WaitSeconds(0.1)
            DamageRing(self, position, 45, self.NukeInnerRingRadius, 1, 'Force', true)
            WaitSeconds(5)
            DamageRing(self, position, 45, self.NukeInnerRingRadius + 15, 1, 'Fire', true)
            WaitSeconds(5)
            DamageRing(self, position, 45, self.NukeInnerRingRadius + 15, 1, 'Fire', true)
            WaitSeconds(5)
            DamageRing(self, position, 45, self.NukeInnerRingRadius + 15, 1, 'Fire', true)
            WaitSeconds(5)
            DamageRing(self, position, 45, self.NukeInnerRingRadius + 15, 1, 'Fire', true)
            WaitSeconds(5)
            DamageRing(self, position, 45, self.NukeInnerRingRadius + 15, 1, 'Fire', true)
        end
    end,

}
TypeClass = SeraphimNukeEffectController01
end
