do
local OldBeamWeapon = DefaultBeamWeapon
DefaultBeamWeapon = Class(OldBeamWeapon) {

    BeamLifetimeThread = function(self, beam, lifeTime)
        WaitSeconds(lifeTime + 0.2)
        self:PlayFxBeamEnd(beam)
    end,
}

local OldProjectileWeapon = DefaultProjectileWeapon
DefaultProjectileWeapon = Class(OldProjectileWeapon) {       
    CreateProjectileAtMuzzle = function(self, muzzle)
        local bp = self:GetBlueprint()
        local proj = nil
        if bp.AmmoUsed then
            if self.unit:GetFuelRatio() >= bp.AmmoUsed then
                self.unit:SetFuelRatio(math.ceil((self.unit:GetFuelRatio() - (bp.AmmoUsed/5))*1000)/1000) -- P 12/14/2009: Modified to reduce ammo effect
                proj = OldProjectileWeapon.CreateProjectileAtMuzzle(self, muzzle)
                if self.unit:GetFuelRatio() < bp.AmmoUsed then
                    self.unit:SetFuelRatio(0)
                end
            end
        else
            proj = OldProjectileWeapon.CreateProjectileAtMuzzle(self, muzzle)
        end
        return proj
    end,
}
end
