--[[
do
local OldWreckage = Wreckage
Wreckage = Class(OldWreckage) {

    DoTakeDamage = function(self, instigator, amount, vector, damageType)
        local maxHealth = self:GetMaxHealth()
        self:AdjustHealth(instigator, -amount)
        local health = self:GetHealth()
        if health > 0 then
            local healthRatio = health / maxHealth
            if not self.MaxReclaimTimeMassMult then
                self.MaxReclaimTimeMassMult = self.ReclaimTimeMassMult
            end
            if not self.MaxReclaimTimeEnergyMult then
                self.MaxReclaimTimeEnergyMult = self.ReclaimTimeEnergyMult
            end
            local mtime = self.MaxReclaimTimeMassMult * healthRatio
            local etime = self.MaxReclaimTimeEnergyMult * healthRatio
            local mass = self.MaxMassReclaim * healthRatio
            local energy = self.MaxEnergyReclaim * healthRatio
            self:SetReclaimValues( mtime, etime, mass, energy)
            LOG("|| Wreckage DoTakeDamage" .. mass)
        elseif health <= 0 then
            self:Destroy()
        end
    end,
    
}
end
--]]