do
local Entity = import('/lua/sim/Entity.lua').Entity
local OldProjectile = CDFLaserDisintegrator02 
CDFLaserDisintegrator02 = Class(OldProjectile) { 
    OnImpact = function(self, targetType, targetEntity)
        OldProjectile.OnImpact(self,targetType,targetEntity)
        if IsUnit(targetEntity) then
            if not targetEntity:IsDead() then
                if not EntityCategoryContains(categories.COMMAND, targetEntity) then
                    if not targetEntity.SpyEnt then
                        local instigator = self:GetLauncher()
                        if instigator.SpyModeMultiplier < 1 then
                            targetEntity.SpyEnt = Entity {}
                            instigator.Trash:Add(targetEntity.SpyEnt)
                            targetEntity.SpyEnt:InitIntel(instigator:GetArmy(), 'Vision', targetEntity:GetBlueprint().Intel.VisionRadius or 0)
                            targetEntity.SpyEnt:EnableIntel('Vision')
                            targetEntity.SpyEnt:AttachBoneTo(-1, targetEntity, 0)
                            if not instigator.SpyUnits then
                                instigator.SpyUnits = {}
                            end
                            table.insert(instigator.SpyUnits,targetEntity)
                        end
                    end
                end
            end
        end
    end,
}
TypeClass = CDFLaserDisintegrator02
end