#
# Seraphim T3 Mobile Artillery
#

local EffectTemplate = import('/lua/EffectTemplates.lua')
local OldProjectile = SIFSuthanusArtilleryShell01
SIFSuthanusArtilleryShell01 = Class(OldProjectile) {
    --FxImpactUnit = EffectTemplate.TAntiMatterShellHit01,
    --FxImpactProp = EffectTemplate.TAntiMatterShellHit01,
    --FxImpactLand = EffectTemplate.TAntiMatterShellHit01,
    FxLandHitScale = 2,

    OnImpact = function(self, targetType, targetEntity)
        OldProjectile.OnImpact(self, targetType, targetEntity)
        ForkThread(self.ForceThread, self, self:GetPosition())
    end,
    ForceThread = function(self, pos)
        DamageArea(self, pos, 7, 1, 'Force', true)
        WaitTicks(2)
        DamageArea(self, pos, 7, 1, 'Force', true)
    end,
}

TypeClass = SIFSuthanusArtilleryShell01